    var config = {
        type: Phaser.AUTO,
        canvas: gameCanvas,
        physics: {
            default: 'arcade',
            arcade: {
                gravity: { y:-0 },
                debug: false
            }
        },
        scene: {
            preload: preload,
            create: create,
            update: update
        }
    };

    var game = new Phaser.Game(config);
    var ammocounter;
    var altammocounter;
    var distance =0;
    var distance_flyer=0;
    var distance_invis = 0;
    var distance_archer = 0;
    var distance_boss = 0;
    var wall;
    var lives;
    var dash_cooldown = 1;
    var player;
    var answer_done = 0;
    var bullettime;
    var current_answer;
    var no_other_1;
    var no_other_2;
    var no_other_3;
    var no_other_4;
    var bow_ammo;
    var pick;
    var enemydead = 0;
    var archerdead = 0;
    var flyerdead = 0;
    var invisdead = 0;
    var bossdead = 0;
    var current_level =1;
    var key1 = 0;
    var key2 = 0;
    var key3 = 0;
    var key4 = 0;
    var stamina = 300;
    var dashing = 0;
    var altammo = 3;
    var i;
    var charge_cooldown = 0;
    var j;
    var enemylives;
    var archerlives;
    var spread;
    var bosslives;
    var bossBullet;
    var bossAttackTime=0;
    var attackEnd=1;
    var counting = 0;
    var speed_boss = 180;
    var flyer_lives = 25;    ;
    var counting_enemy = 0;
    var attack_enemyend = 1;
    var enemy_attacktime = 0;
    var invislives = 20;
    var invisspeed = 220;
    var bow_ammo_plus=0;
    var screen1=0;
    var screen2=0;
    var screen3=0;
    var screen4=0;
    var correct = [
        "0.9",
        "48",
        "8",
        "12",
        "169",
        "14",
        "35",
        "37",
        "0",
        "-15",
        "Oblicz ⅔*⅘",
        "9",
        "3",
        "120",
        "-14",
        "12",
        "9",
        "154",
        "5%",
        "1",
        "240",
        "729",
        "126",
        "132",
        "0",
        "20m",
        "2s",
        "1000N",
        "24m",
        "19s",
        "200N",
        "Resublimacja",
        "Sublimacja",
        "Topnienie",
        "skraplanie",
        "1/2Hz",
        "0.04Hz",
        "2Hz",
        "1450N",
        "240N",
        "6kg/m^3",
        "343m/s",
        "100000Pa",
        "7500Pa",
        "10Pa",
        "2000J",
        "1J",
        "0,072J",
        "2m",
        "320m",
        
    ];

    var ammorewards = [
        "2",
        "1",
        "4",
        "1",
        "2",
        "1",
        "3",
        "2",
        "5",
        "2",
        "2",
        "3",
        "1",
        "4",
        "2",
        "3",
        "3",
        "2",
        "2",
        "3",
        "5",
        "5",
        "7",
        "3",
        "2",
        "2",
        "3",
        "2",
        "2",
        "3",
        "2",
        "5",
        "5",
        "3",
        "3",
        "3",
        "3",
        "5",
        "3",
        "2",
        "2",
        "8",
        "2",
        "5",
        "5",
        "5",
        "3",
        "8",
        "10",
        "20"
    ];
    var liferewards = [
        "2",
        "1",
        "4",
        "1",
        "2",
        "1",
        "3",
        "2",
        "5",
        "2",
        "2",
        "3",
        "1",
        "4",
        "2",
        "3",
        "3",
        "2",
        "2",
        "3",
        "5",
        "5",
        "7",
        "3",
        "2",
        "2",
        "3",
        "2",
        "2",
        "3",
        "2",
        "5",
        "5",
        "3",
        "3",
        "3",
        "3",
        "5",
        "3",
        "2",
        "2",
        "8",
        "2",
        "5",
        "5",
        "5",
        "3",
        "8",
        "10",
        "20"
    ];
    var texts = [
        "Oblicz 0.5+0.4",
        "Oblicz 4*12",
        "Oblicz przeciwprostokątną trójkąta prostokątnego równoramiennego o polu 16",
        "Oblicz 84:7",
        "Oblicz 13^2",
        "Oblicz 2+3*4",
        "Oblicz x: 2*x+1=71",
        "Oblicz 111/3",
        "Oblicz((3^2-(2*2^2)-1)*99999)",
        "Oblicz -12+4-7",
        "Oblicz ⅔*⅘",
        "Ile przekątnych ma sześciokąt foremny?",
        "Ile wynosi liczba pi zaokrąglona do liczb całkowitych?",
        "Oblicz 5!",
        "Oblicz 15-29",
        "Oblicz 144^(½)",
        "Oblicz pole trapezu o podstawach 2 i 4 oraz wysokości 3.",
        "Oblicz 14*11",
        "Oblicz stężenie procentowe roztworu o masie 100 gramów w którym rozpuszczono 5 gramów soli",
        "Oblicz  stosunek pola do obwodu kwadratu o boku równym 4",
        "Oblicz (19^2-11^2)",
        "Oblicz 9^3",
        "Sklep obniżył początkowo cenę butów, które kosztowały oryginalnie 150 złotych, o 30%. Miesiąc później podwyższył ich aktualną cenę o 20%. Ile kosztują teraz buty?",
        "Oblicz (121/11)*12",
        "Oblicz 45% z 45% z 45% z 45% z 45% z 45% z 45% z 0",
        "Ciało leci z prędkością 10 m/s. Ile przeleci w 2 sekundy?",
        "Ciało ma przyspieszenie 5m/s^2. Zaczynało z prędkością 0 m/s. Teraz ma prędkość 10 m/s. Ile czasu minęło?",
        "Oblicz siłę, która daje przyspieszenie 5m/s^2 ciału o masie 200kg.",
        "Ciało leci z prędkością 2 m/s. Ile przeleci w 12 sekund?",
        "Ciało ma przyspieszenie 4m/s^2. Zaczynało z prędkością 0 m/s. Teraz ma prędkość 76 m/s. Ile czasu minęło?",
        "Oblicz siłę, która daje przyspieszenie 2m/s^2 ciału o masie 100kg.",
        "Napisz nazwę procesu przejścia ciała ze stanu gazowego na stały, z pominięciem stanu ciekłego.",
        "Napisz nazwę procesu przejścia ciała ze stanu stałego na gazowy, z pominięciem stanu ciekłego.",
        "Napisz nazwę procesu przejścia ciała ze stanu stałego na ciekły.",
        "Napisz nazwę procesu przejścia ciała ze stanu gazowego na ciekły.",
        "Oblicz częstotliwość drgania o okresie równym 2s.",
        "Oblicz częstotliwość drgania o okresie równym 25s.",
        "Oblicz częstotliwość drgania o okresie równym ½ s.",
        "Oblicz ciężar ciała o masie 145 kg. Przyjmij, że g = 10.",
        "Oblicz ciężar ciała o masie 24 kg. Przyjmij, że g = 10.",
        "Oblicz gęstość sześcianu o boku 5m i masie 750kg.",
        "Podaj wartość prędkości dźwięku w warunkach normalnych.",
        "Na dno pudełka będące kwadratem o boku 10cm działa siła 1000N. Oblicz ciśnienie.",
        "Na dno pudełka będące kwadratem o boku 20cm działa siła 300N. Oblicz ciśnienie.",
        "Na dno pudełka będące kwadratem o boku 1m działa siła 10N. Oblicz ciśnienie.",
        "Sprężyna rozciągnęła się o 2m. Współczynnik sprężystości wynosi 1000 N/m. Oblicz energię potencjalną sprężystości tej sprężyny.",
        "Sprężyna rozciągnęła się o 20cm. Współczynnik sprężystości wynosi 50 N/m. Oblicz energię potencjalną sprężystości tej sprężyny.",
        "Sprężyna rozciągnęła się o 12cm. Współczynnik sprężystości wynosi 10 N/m. Oblicz energię potencjalną sprężystości tej sprężyny.",
        "Energia potencjalna sprężystości sprężyny wynosi 20J. Współczynnik sprężystości wynosi 10N/m. Oblicz, o ile rozciągnęła się sprężyna.",
        "Energia potencjalna sprężystości sprężyny wynosi 32000 J. Współczynnik sprężystości wynosi 0,625N/m. Oblicz, o ile rozciągnęła się sprężyna."
    ];
    var first_answers = [
        "0.9",
        "35",
        "8",
        "14",
        "129",
        "20",
        "35",
        "37",
        "99999",
        "-23",
        "8/15",
        "4",
        "2",
        "120",
        "14",
        "146",
        "18",
        "150",
        "10%",
        "4",
        "240",
        "700",
        "126",
        "130",
        "0",
        "10m", "2s", "500N", "12m", "76s",
        "100N", "Resublimacja", "Resublimacja", "Topnienie", "Topnienie",
        "1/2Hz", "0.04Hz", "5Hz", "1300N", "240N",
        "6kg/m^3", "343m/s", "100000Pa", "75000Pa", "10Pa",
        "1000J", "2J", "0.072J", "2m", "1024m"
    ];
    var next_pick = Phaser.Math.Between(0, texts.length - 1);
    var second_answers = [
        "0.75",
        "48",
        "4",
        "12",
        "149",
        "11",
        "70",
        "74",
        "0",
        "-1",
        "15/8",
        "8",
        "3",
        "720",
        "44",
        "14",
        "9",
        "154",
        "100%",
        "2",
        "200",
        "109",
        "150",
        "131",
        "45",
        "20m", "3s", "1000N", "24m", "38s",
        "200N", "Sublimacja", "Sublimacja", "Skraplanie", "Skraplanie",
        "2Hz", "25Hz", "1/2Hz", "1500N", "480N",
        "8kg/m^3", "342m/s", "5000Pa", "750000Pa", "5Pa",
        "20000J", "1J", "0.36J", "8m", "24m"
    ];
    var third_answers = [
        "0.2",
        "120",
        "16",
        "7",
        "169",
        "22",
        "140",
        "73",
        "19998",
        "23",
        "1",
        "9",
        "4",
        "120",
        "-15",
        "12",
        "12",
        "104",
        "5%",
        "8",
        "160",
        "729",
        "162",
        "121",
        "2025",
        "12m", "1s", "2000N", "2m", "19s",
        "500N", "Skraplanie", "Topnienie", "Krzepnięcie", "Sublimacja",
        "1Hz", "1Hz", "1Hz", "2450N", "250N",
        "4kg/m^3", "363m/s", "1000Pa", "750Pa", "2Pa",
        "2000J", "5J", "0.72J", "10m", "240m"
    ]
    var flyer_speed  = 200;
    var fourth_answers = [
        "0.6",
        "84",
        "2",
        "11",
        "196",
        "14",
        "71",
        "27",
        "1",
        "-15",
        "1/2",
        "6",
        "5",
        "24",
        "-14",
        "144",
        "108",
        "144",
        "20%",
        "1",
        "320",
        "927",
        "326",
        "132",
        "1/45",
        "40m", "4s", "2000N", "6m", "10s",
        "2000N", "Krzepnięcie", "Topnienie", "Sublimacja", "Krzepnięcie",
        "4Hz", "0.2Hz", "2Hz", "1450N", "500N",
        "5kg/m^3", "303m/s", "100Pa", "7500Pa", "100Pa",
        "4000J", "20J", "0.144J", "4m", "320m"  
    ];

    function preload ()
    {
            this.load.image('player', 'gracz_demo.png');
        this.load.image('enemy', 'enemy.png');
        this.load.image('enemy_archer', 'enemy_archer.png');
        this.load.image('bg', 'tlo_demo.png');
        this.load.image('wall', 'wall.png');
        this.load.image('wall2', 'wall.png');
        this.load.image('bullet', 'bullet.png');
        this.load.image('enemy_bullet', 'enemy_bullet.png');
        this.load.image('ammoimage', 'ammoimage.png');
        this.load.image('gameover', 'gameover.png');
        this.load.image('youwin', 'youwin.png');
        this.load.image('heart', 'heart.png');
        this.load.image('enemyheart', 'enemyheart.png');
        this.load.image('boss', 'boss.png');
        this.load.image('bossBullet', 'bossBullet.png');
        this.load.image('altbullet', 'altbullet.png');
        this.load.image('meleebullet', 'melee_bullet.png');
        this.load.image('flyer', 'flyer.png');
        this.load.image('invis', 'invis.png');
        this.load.image('invis_bullet', 'invisbullet.png');
        this.load.image('potion', 'potion.png');
        this.load.image('potion_floor', 'potion_floor.png');
        this.load.image('key1', 'keyshard1.png');
        this.load.image('key2', 'keyshard2.png');
        this.load.image('key3', 'keyshard3.png');
        this.load.image('key4', 'keyshard4.png');
        this.load.image('screen1', 'screen1.png');
        this.load.image('screen2','screen2.png');
        this.load.image('screen3','screen3.png');
        this.load.image('screen4','screen4.png');


    }
    bullet_enemy_cooldown = 0;
    function create ()
    {
        number = this.add.image (666,200)
        bullettime = 0;
        this.add.image(345, 120, "bg").setScale(5).setDepth(-1);
        wall = this.physics.add.staticGroup();
        wall = this.physics.add.staticGroup();
        lives = 1000;    
        
        
        
        for(var i =0;i<20;i++)
        {wall.create(20+60*i,200,'wall').setImmovable(true);}
        
        for(var j =0;j<20;j++)
        {wall.create(20,10+60*j,'wall').setImmovable(true);}

        for(var j =0;j<20;j++)
        {wall.create(1000,10+60*j,'wall').setImmovable(true);}
        
        for(var i =0;i<20;i++)
        {wall.create(20+60*i,770,'wall').setImmovable(true);}

        player = this.physics.add.image(100, 300, 'player');
        player.bounce = -100;
    
        if(current_level ==1)
        {enemy = this.physics.add.image(600,300,'enemy');
        enemy.setCollideWorldBounds(true);
        }
        else
        enemy = this.physics.add.image(6000000, 30000000, 'enemy');
        

        player.setCollideWorldBounds(true); 

        enemy_archer= this.physics.add.image(500,400, 'enemy_archer');
        flyer = this.physics.add.image(300,600, 'flyer');
        invis = this.physics.add.image(700,700,'invis');
        enemy_archer.setCollideWorldBounds(true);
        invis.setCollideWorldBounds(true);
        flyer.setCollideWorldBounds(true);
        boss = this.physics.add.image(600,600,'boss'); 
        boss.setCollideWorldBounds(true);
        this.physics.add.collider(player, wall);
        this.physics.add.collider(flyer, wall);
        this.physics.add.collider(enemy, wall);
    
        this.physics.add.collider(enemy_archer, wall);
    
        this.physics.add.collider(invis, wall);
        heart = this.physics.add.image(player.x+15, player.y-player.width-5, 'heart').setScale(3);
        enemyheart = this.physics.add.image(enemy.x+15, enemy.y-enemy.width-5, 'enemyheart').setScale(3);
        invisheart = this.physics.add.image(invis.x+15, invis.y-invis.width-5, 'enemyheart').setScale(3);
        enemy_archerheart = this.physics.add.image(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5, 'enemyheart').setScale(3);
        flyer_heart = this.physics.add.image(flyer.x+15, flyer.y-flyer.width-5, 'enemyheart').setScale(3);
        livesCounter = this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        enemyLiveCounter = this.add.text(enemy.x-20,enemy.y-enemy.width-10,enemylives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        enemy_archerLiveCounter = this.add.text(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10,archerlives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        invisLiveCounter = this.add.text(invis.x-20,invis.y-invis.width-10,invislives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        flyerLiveCounter = this.add.text(flyer.x-20,flyer.y-flyer.width-10,flyer_lives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        bossLiveCounter = this.add.text(boss.x-30,boss.y-boss.width-30,bosslives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        bossheart = this.physics.add.image(boss.x+15, boss.y-boss.width-15, 'enemyheart').setScale(3);
    
    this.physics.add.collider(boss,wall);
        this.physics.add.collider(boss,enemy);
        this.physics.add.collider(boss,enemy_archer);
        function player_enemy(player, enemy) {
            if(dashing==0)
            {lives-=0.1;
            
            }
            
        }


        function player_invis(player, invis) {
            if(dashing==0)
            {lives-=0.1;
            
            }
            
        }


        

        function player_boss(player, boss) {
            if(dashing==0)
            lives-=1;
            boss.setVisible(false); 
            boss.setVisible(true);
        }
        this.physics.add.collider(player, boss, player_boss, null, this);

        this.physics.add.collider(player, enemy, player_enemy, null, this);
        this.physics.add.collider(player, invis, player_invis, null, this);
        
        

        this.cursors = this.input.keyboard.addKeys({
            up: Phaser.Input.Keyboard.KeyCodes.W,
            down: Phaser.Input.Keyboard.KeyCodes.S,
            left: Phaser.Input.Keyboard.KeyCodes.A,
            right: Phaser.Input.Keyboard.KeyCodes.D,
            one: Phaser.Input.Keyboard.KeyCodes.ONE,
            two: Phaser.Input.Keyboard.KeyCodes.TWO,
            three: Phaser.Input.Keyboard.KeyCodes.THREE,
            four: Phaser.Input.Keyboard.KeyCodes.FOUR,
            dash: Phaser.Input.Keyboard.KeyCodes.SPACE,
        });
    bow_ammo = 20;
    var randomIndex = Phaser.Math.Between(0, texts.length - 1);

    this.input.on('pointerdown',function (pointer){
        if(pointer.leftButtonDown())
            if(bow_ammo >0)
                {  

                if(bow_ammo==1)
                    bow_ammo_plus=1;
                bow_ammo -=1;
                
                ammocounter.setText(bow_ammo);
               
                bullet = this.physics.add.image(player.x,player.y,'bullet');
               
                
                if(enemydead == 0&&current_level==1)
                { function stopBullet_enemy(bullet, enemy) {
                    enemylives-=1;
                    bullet.setVelocity(0, 0);
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }
            }

            if(invisdead == 0&&current_level==4)
            { function stopBullet_invis(bullet, invis) {
            invislives-=1;
            bullet.setVelocity(0, 0);
            bullet.setVisible(false); 
            bullet.destroy(); 
        }
    }


    if(flyerdead==0&&current_level==3)
    {function stopBullet_flyer(bullet, flyer) {
                    flyer_lives-=1;
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                function stopBullet(bullet, wall) {
                
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }
                if(archerdead==0&&current_level==2)
                {function stopBullet_enemyarcher(bullet, enemy_archer) {
                    archerlives-=1;
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                if(bossdead==0&&current_level==5)
                {function stopBullet_boss(bullet, boss) {
                    bosslives-=1;
                    bullet.setVelocity(0, 0);

                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                if(invisdead==0&&current_level==4)
                this.physics.add.collider(bullet,  invis, stopBullet_invis, null, this);
                if(flyerdead==0&&current_level==3)
                this.physics.add.collider(bullet, flyer, stopBullet_flyer, null, this);
                this.physics.add.collider(bullet, wall, stopBullet, null, this);
                if(enemydead == 0&&current_level==1)
                this.physics.add.collider(bullet, enemy, stopBullet_enemy, null, this);
            if(archerdead==0&&current_level==2)
                this.physics.add.collider(bullet, enemy_archer, stopBullet_enemyarcher, null, this);
            if(bossdead==0&&current_level==5)
                this.physics.add.collider(bullet, boss, stopBullet_boss, null, this);  
                }
                },this);
            

                this.input.on('pointerdown',function (pointer){
                    if(pointer.middleButtonDown())
                        if(altammo >0&&player.x > 90&&player.x<900&&player.y>300&&player.y<710)
                            {  
                                altammo -=1;
                            altbullet = this.physics.add.image(player.x,player.y,'altbullet');
                    
                            altammocounter.setVisible(false);
                            altammocounter =  this.add.text(820,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
                            altammocounter.setVisible(true);
                            
                            
                            if(enemydead ==0&&current_level==1)
                            {function stopBullet_enemy(altbullet, enemy) {
                                enemylives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}

                            if(invisdead ==0&&current_level==4)
                        { function stopBullet_invis(altbullet, invis) {
                                invislives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}
                
                            function stopBullet(altbullet, wall) {
                            
                                altbullet.setVelocity(0, 0);
                                
                                bullet.setVisible(false); 
                                bullet.destroy(); 
                            }
                            if(archerdead==0&&current_level==2)
                            {function stopBullet_enemyarcher(altbullet, enemy_archer) {
                                archerlives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }
                        }
                        if(bossdead==0&&current_level==5)    
                        {function stopBullet_boss(altbullet, boss) {
                                bosslives-=5;
                                altbullet.setVelocity(0, 0);
                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}
                
                            
                            this.physics.add.collider(altbullet, wall, stopBullet, null, this);
                            if(enemydead == 0&&current_level==1)
                            this.physics.add.collider(altbullet, enemy, stopBullet_enemy, null, this);
                            if(invisdead==0&&current_level==4)
                            this.physics.add.collider(altbullet, invis, stopBullet_invis, null, this);
                        if(archerdead==0&&current_level==2)
                            this.physics.add.collider(altbullet, enemy_archer, stopBullet_enemyarcher, null, this);
                        if(bossdead==0&&current_level==5)
                            this.physics.add.collider(altbullet, boss, stopBullet_boss, null, this);  
                            }
                            },this);
                        
    current_answer = 10;
    group = this.add.group();    


        
        for (var i = 0; i < texts.length; i++) {
            var text = this.add.text(100, 10, texts[i],{ fontFamily: 'Arial', fontSize: 14, color: ' #0000ff ' });
            group.add(text);
            text.setVisible(false); 
        }

        

        pick = randomIndex;
        
        
        randomText = group.getChildren()[randomIndex];
        
        randomText.setVisible(true);
        ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
        ammoimage =  this.add.image(790,117,'ammoimage').setScale(0.3);
        altammocounter =  this.add.text(820,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
        altammoimage =  this.add.image(860,117,'altbullet').setScale(0.3);




    group_firsts = this.add.group();    
        
        for (var i = 0; i < first_answers.length; i++) {
            var text_first = this.add.text(100, 40, first_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_firsts.add(text_first);
            text_first.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_1 = group_firsts.getChildren()[randomIndex];
        
        randomText_1.setVisible(true);
    archerlives = 20;
    enemylives = 30;
    bosslives = 50;
    group_seconds = this.add.group();    
        
        for (var i = 0; i < second_answers.length; i++) {
            var text_second = this.add.text(100, 70, second_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_seconds.add(text_second);
            text_second.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_2 = group_seconds.getChildren()[randomIndex];
        
        randomText_2.setVisible(true);


    group_thirds = this.add.group();    
        
        for (var i = 0; i < third_answers.length; i++) {
            var text_third = this.add.text(100, 100, third_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_thirds.add(text_third);
            text_third.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_3 = group_thirds.getChildren()[randomIndex];
        
        randomText_3.setVisible(true);


    group_fourths = this.add.group();    
        
        for (var i = 0; i < fourth_answers.length; i++) {
            var text_fourth = this.add.text(100, 130, fourth_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_fourths.add(text_fourth);
            text_fourth.setVisible(false); 
        }

        
        var randomIndex = pick;
        
        randomText_4 = group_fourths.getChildren()[randomIndex];
        
        randomText_4.setVisible(true);
    }



    function update ()
    {  {{{{{{{{{
        no_other_1 = 0;
        no_other_2 = 0;
        no_other_3 = 0;
        no_other_4 = 0;


        if(this.cursors.four.isUp && this.cursors.two.isUp && this.cursors.three.isUp) {
            no_other_1=1;
        }
        if(this.cursors.one.isUp && no_other_1 == 1)
            current_answer = 0;   
            
        
        if(this.cursors.one.isUp && this.cursors.three.isUp && this.cursors.four.isUp) {
            no_other_2=1;
        }    
        if(this.cursors.one.isUp && this.cursors.two.isUp && this.cursors.four.isUp) {
            no_other_3=1;
        } 
        if(this.cursors.one.isUp && this.cursors.two.isUp && this.cursors.three.isUp) {
            no_other_4=1;
        }
        
        
    if(this.cursors.one.isDown && no_other_1 == 1 && current_answer == 0)
        {current_answer = 1;
        answer_done=1;}

    if(this.cursors.two.isDown && no_other_2 == 1 && current_answer == 0)
        {current_answer = 2;
        answer_done=1;}
    if(this.cursors.three.isDown && no_other_3 == 1 && current_answer == 0)
        {current_answer = 3;
        answer_done=1;}
    if(this.cursors.four.isDown && no_other_4 == 1 && current_answer == 0)
        {current_answer = 4;
        answer_done=1;}
        

        
    if(current_answer ===1 && answer_done <2)
    {
        if(first_answers[pick] === correct[pick] )
    { bow_ammo+=Number(ammorewards[pick]);
        altammo+=Math.floor(Number(ammorewards[pick])/5);
        lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
            answer_done++
            }

            
    }
    if(current_answer ===2 && answer_done <2)
    {
        if(second_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
            answer_done++};
        
    }}

    

    if(current_answer ===3 && answer_done <2)
    {
        if(third_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
        answer_done++};
        
    }
    if(current_answer ===4 && answer_done < 2)
    {
        if(fourth_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
        answer_done++;}
        
    }
    
    if(answer_done == 2) {
        randomText.setVisible(false);
        pick = (pick + next_pick) % texts.length; 
        randomText = group.getChildren()[pick];
        randomText.setVisible(true);
        randomText_1.setVisible(false);
        randomText_1 = group_firsts.getChildren()[pick];
        randomText_1.setVisible(true);
        randomText_2.setVisible(false);
        randomText_2 = group_seconds.getChildren()[pick];
        randomText_2.setVisible(true);
        randomText_3.setVisible(false);
        randomText_3 = group_thirds.getChildren()[pick];
        randomText_3.setVisible(true);
        randomText_4.setVisible(false);
        randomText_4 = group_fourths.getChildren()[pick];
        randomText_4.setVisible(true);
        answer_done =  3;
    }


    if(this.cursors.dash.isUp)
    dash_cooldown++;


    if(this.cursors.dash.isDown)
    {if(stamina >= 0 && dash_cooldown>30)
    {dashing = 10;
    stamina -=30;
    dash_cooldown = 0;
    }
    else
    stamina=(stamina+1)%300;
    }

        
        if (this.cursors.left.isDown)
        {
            player.setVelocityX(-220*(dashing/3+1));
        
        
        }
        else 
        if (this.cursors.right.isDown)
        {
            player.setVelocityX(220*(dashing/3+1));
        
        
        }
        else
        {
        player.setVelocityX(0);

        }
        
        if (this.cursors.up.isDown)
        {
            player.setVelocityY(-220*(dashing/3+1));
        
        
        }
        else if (this.cursors.down.isDown)
        {
            player.setVelocityY(220*(dashing/3+1));
        
        
        }
        
        else
        {
        player.setVelocityY(0);
        }
    if(bullettime %60 < 55&& current_level ==4)
    invis.setVisible(false);
    else
    {if(current_level==4)
    invis.setVisible(true);}

    bullettime=(bullettime+1)%600;
        if(enemydead == 0&&current_level==1)
    {var diffX = player.x - enemy.x;
        var diffY = player.y - enemy.y;
        var distance = Math.sqrt(diffX*diffX+diffY*diffY);
        }
        
        if(current_level==1)
        var speed  = 70;
        
    if(distance < 300&&current_level==1)
        { var speed = 200;
        
        }





    if(distance < 1500&& enemydead ==0&&current_level==1)
    {enemy.setVelocityX(  speed*(diffX/distance));
        enemy.setVelocityY(  speed*(diffY/distance));
    }   


    if(current_level !=2&&archerdead == 0)
    {enemy_archer.x = 1500;
    enemy_archer.y = 1000;

    }

    if(current_level !=3&&flyerdead==0)
    {flyer.x = 1500;
    flyer.y = 1000;
    }

    if(current_level !=4&&invisdead==0)
    {invis.x = 1500;
    invis.y = 1000;
    }

    if(current_level !=5&&bossdead==0)
    {boss.x = 1500;
    boss.y = 1000;
    }
    if(current_level==1)
        var shootgap = (player.x-enemy.x)/Math.abs(player.x-enemy.x);
    if(distance > 80 && distance < 1500&&current_level==1 &&bullettime%45==0&& enemydead == 0)
    {meleebullet = this.physics.add.image(enemy.x+50*shootgap, enemy.y, 'meleebullet').setScale(1.16);

            
            var speedBullet_melee = 500;
    var diffBulletX_melee = player.x - enemy.x;
    var diffBulletY_melee = player.y - enemy.y;
    var distanceBullet_melee = Math.sqrt(diffBulletX_melee * diffBulletX_melee + diffBulletY_melee * diffBulletY_melee);
    var bullet_meleeAngle = Math.atan(diffBulletY_melee/diffBulletX_melee);

    meleebullet.setRotation(bullet_meleeAngle);
    meleebullet.setVelocityX(speedBullet_melee * (diffBulletX_melee /distanceBullet_melee));  
    meleebullet.setVelocityY(speedBullet_melee * (diffBulletY_melee /distanceBullet_melee));  
    


    function meleebullet_player(meleebullet, player) {
        if(dashing==0)
        {lives -= 10;
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
        }
        else
        meleebullet.setVelocity(-2*speedBullet_melee * (diffBulletX_melee / distanceBullet_melee), -2*speedBullet_melee * (diffBulletY_melee / distanceBullet_melee));
    }

    function meleeBulletwall(meleebullet, wall) {
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
    }

    function meleebullet_enemy(meleebullet, enemy) {
        enemylives -= 1;
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
    }


    this.physics.add.collider(meleebullet, wall, meleeBulletwall, null, this);
    this.physics.add.collider(meleebullet, player, meleebullet_player, null, this);
    this.physics.add.collider(meleebullet, enemy, meleebullet_enemy, null, this);
    }}}
    if(invisdead==0&&current_level==4)
    {var diffX_invis = player.x - invis.x;
    var diffY_invis = player.y - invis.y;
    var distance_invis = Math.sqrt(diffX_invis*diffX_invis+diffY_invis*diffY_invis);}




    if(distance_invis < 1500&&current_level==4&&invisdead==0)
    {invis.setVelocityX(  invisspeed*(diffX_invis/distance_invis));
    invis.setVelocityY(  invisspeed*(diffY_invis/distance_invis));
    }   


    if(distance_invis > 250 && distance_invis < 1500 &&current_level==4&&bullettime%45<4&&invisdead==0)
    {invisbullet = this.physics.add.image(invis.x, invis.y, 'invis_bullet').setScale(1.16);
   
        
        var speedBullet_invis = 1000;
    var diffBulletX_invis = player.x - invis.x;
    var diffBulletY_invis = player.y - invis.y;
    var distanceBullet_invis = Math.sqrt(diffBulletX_invis * diffBulletX_invis + diffBulletY_invis * diffBulletY_invis);
    var bullet_invisAngle = Math.atan(diffBulletY_invis/diffBulletX_invis);

    invisbullet.setRotation(bullet_invisAngle);
    invisbullet.setVelocityX(speedBullet_invis * (diffBulletX_invis /distanceBullet_invis));  
    invisbullet.setVelocityY(speedBullet_invis * (diffBulletY_invis /distanceBullet_invis));  
   


    function invisbullet_player(invisbullet, player) {
    if(dashing==0)
    {lives -= 15;
    invisbullet.setVelocity(0, 0);
    invisbullet.setVisible(false);
    invisbullet.destroy();
    }
    else
    invisbullet.setVelocity(-2*speedBullet_invis * (diffBulletX_invis / distanceBullet_invis), -2*speedBullet_invis * (diffBulletY_invis / distanceBullet_invis));
    }

    function invisBulletwall(invisbullet, wall) {
    invisbullet.setVelocity(0, 0);
    invisbullet.setVisible(false);
    invisbullet.destroy();
    }



    this.physics.add.collider(invisbullet, wall, invisBulletwall, null, this);
    this.physics.add.collider(invisbullet, player, invisbullet_player, null, this);

    }}}



    if(flyerdead==0&&current_level==3)
    {var diffX_flyer = player.x - flyer.x;
    var diffY_flyer = player.y - flyer.y;
    var distance_flyer = Math.sqrt(diffX_flyer*diffX_flyer+diffY_flyer*diffY_flyer);}







    if(distance_flyer<1500&&flyerdead==0&&current_level==3)
    {flyer.setVelocityX(  flyer_speed*(diffX_flyer/distance_flyer));
    flyer.setVelocityY(  flyer_speed*(diffY_flyer/distance_flyer));
    }   


    if(distance_flyer < 1500 &&bullettime%60<1&&flyerdead==0&&current_level==3)
    {flyerbullet = this.physics.add.image(flyer.x, flyer.y, 'altbullet').setScale(0.5);
  

        
    

    function flyerbulletplayer(flyerbullet, player) {
    if(dashing==0)
    {lives -= 10;
    flyerbullet.setVelocity(0, 0);
    flyerbullet.setVisible(false);
    flyerbullet.destroy();
    }
    else
    flyerbullet.destroy();
    }
    function flyerBulletwall(flyerbullet, wall) {
    flyerbullet.setVelocity(0, 0);
    flyerbullet.setVisible(false);
    flyerbullet.destroy();
    }
    this.physics.add.collider(flyerbullet, wall, flyerBulletwall, null, this);
    this.physics.add.collider(flyerbullet, player, flyerbulletplayer, null, this);

    }}}








        if(archerdead==0&&current_level==2)
        {var diffX_archer = player.x - enemy_archer.x;
        var diffY_archer = player.y - enemy_archer.y;
        var distance_archer = Math.sqrt(diffX_archer*diffX_archer+diffY_archer*diffY_archer);
        var speed = 100;
        var speedBullet_enemy = 500;}

        if(bossdead==0&&current_level==5)
        {
        var diffX_boss = player.x - boss.x;
        var diffY_boss = player.y - boss.y;
        var distance_boss = Math.sqrt(diffX_boss*diffX_boss+diffY_boss*diffY_boss);
        }
        if(distance_archer < 1500&&archerdead==0&&current_level==2)
            {enemy_archer.setVelocityX(speed*(diffX_archer/distance_archer));
            enemy_archer.setVelocityY(speed*(diffY_archer/distance_archer));}
        
        if(distance_boss < 1500&&bossdead==0&&current_level==5)
        {boss.setVelocityX(speed_boss*(diffX_boss/distance_boss));
        boss.setVelocityY(speed_boss*(diffY_boss/distance_boss));}
        if(bossdead==0&&current_level==5)
        {function bossBullet_player(bossBullet, player) {
            lives -= 5;
            bossBullet.setVelocity(0, 0);
            bossBullet.setVisible(false);
            bossBullet.destroy();
        }}

        bossAttackTime+=1;
        var bossAttack = ['minigun','shoot','potion'];

        if(bossAttackTime>=240 && distance_boss < 1500&&bossdead==0&&current_level==5)
        {
            if(attackEnd == 1)
                {   
                    var randomBossAttack = Phaser.Math.RND.pick(bossAttack);
                    attackEnd = 0;
                    bossAttackTime = 0;
                }
        }

        if(randomBossAttack ==='potion'&&current_level==5)
        {
            speed_boss=0;
            attackEnd = 0;
            counting = 0;
            var potionCounting = [];
            var potionFloorCounting = [];
            for (var j = 0; j < 10; j++) {
                potion = this.physics.add.image(boss.x, boss.y, 'potion');
                potion.setVelocity(Phaser.Math.Between(-300, 300), Phaser.Math.Between(-300, 300));
                potion.setAngularVelocity(Phaser.Math.Between(-200,200));
                counting += 1;

                potionCounting.push(potion);
            }
            setTimeout(() =>{
                for(var j=0; j<potionCounting.length; j++){
                    potionCounting[j].setVelocity(0,0);
                    potionCounting[j].setAngularVelocity(0);
                }
                setTimeout(()=>{
                for(var j=0; j<potionCounting.length; j++){
                    potionCounting[j].setVisible(false);
                    potion_floor = this.physics.add.image(potionCounting[j].x,potionCounting[j].y,'potion_floor').setScale(Phaser.Math.Between(1,2.5)).setDepth(-1);
                    potion_floor.setRotation(Phaser.Math.Between(-300,300));
                    this.physics.add.overlap(potion_floor, player, potionTouch, null, this); 

                    potionFloorCounting.push(potion_floor);
                    setTimeout(()=>{
                    for(var j=0; j<potionCounting.length; j++)
                        potionFloorCounting[j].destroy();
                    },8000)
                }
                },1000);
                if (counting == 10)
                    {
                        attackEnd = 1;
                        speed_boss=210;
                    }
            },1000);
        }

        function potionTouch(player,potion_floor){
                lives-=0.3;
        }
        
        if (randomBossAttack === 'shoot'&&current_level==5) {
            attackEnd = 0;
            counting = 0;
            for (var k = 0; k < 10; k++) {
                var bossBullet = this.physics.add.image(boss.x, boss.y, 'bossBullet');
            
                bossBullet.setVelocity(Phaser.Math.Between(-1500, 1500), Phaser.Math.Between(-1500, 1500));
              
                this.physics.add.collider(bossBullet, player, bossBullet_player, null, this);
                counting += 1;
            }
            if (counting == 10)
                attackEnd = 1;
        }
        
        if(randomBossAttack === 'minigun'&&current_level==5)
        {
            speed_boss=0;
            var angle=0;
            counting=0;
            for(var i=0; i<20; i++){
                setTimeout(() => {
                    bossBullet = this.physics.add.image(boss.x,boss.y,'bossBullet');
                    angle+=30;
                    bossBullet.setVelocity(Math.cos(Phaser.Math.DegToRad(angle))*1000,Math.sin(Phaser.Math.DegToRad(angle))*1000);
                    
                    this.physics.add.collider(bossBullet,player,bossBullet_player,null,this);
                    counting +=1;
                    if(counting==20)
                    {
                        attackEnd=1;
                        speed_boss=300;
                        
                    }
                },i*250)
            }
        }
        





    if(archerdead==0&&current_level==2)
    {var archer_attack_pick =  Phaser.Math.Between(0, 1);
    }
        
        if(bullettime % 60 < 20&& distance_archer<3000&&archerdead==0&&current_level==2)
        { 
            if(archer_attack_pick==0)
            {enemy_bullet = this.physics.add.image(enemy_archer.x, enemy_archer.y, 'enemy_bullet').setScale(0.5);
            
            
            var diffBulletX_enemy = player.x - enemy_archer.x;
            var diffBulletY_enemy = player.y - enemy_archer.y;
            var distanceBullet_enemy = Math.sqrt(diffBulletX_enemy * diffBulletX_enemy + diffBulletY_enemy * diffBulletY_enemy);
            var bullet_enemyAngle = Math.atan(diffBulletY_enemy/diffBulletX_enemy);
        
            enemy_bullet.setRotation(bullet_enemyAngle);
            enemy_bullet.setVelocityX(4*(bullettime%60) + speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy));
            enemy_bullet.setVelocityY(speedBullet_enemy * (diffBulletY_enemy /distanceBullet_enemy));  
   
            
        
            function enemybullet_player(enemy_bullet, player) {
                if(dashing==0)
                {lives -= 2;
                enemy_bullet.setVelocity(0, 0);
                enemy_bullet.setVisible(false);
                enemy_bullet.destroy();
                }
                else
                enemy_bullet.setVelocity(-2*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy), -2*speedBullet_enemy * (diffBulletY_enemy / distanceBullet_enemy));
            }
        
            function enemyBulletwall(enemy_bullet, wall) {
                enemy_bullet.setVelocity(0, 0);
                enemy_bullet.setVisible(false);
                enemy_bullet.destroy();
            }
        
        
        
        
            this.physics.add.collider(enemy_bullet, wall, enemyBulletwall, null, this);
            this.physics.add.collider(enemy_bullet, player, enemybullet_player, null, this);
        }}
        else
        if(bullettime % 60 < 20&& distance_archer<3000&&archerdead==0&&current_level==2)
        {enemy_bullet = this.physics.add.image(enemy_archer.x, enemy_archer.y, 'enemy_bullet').setScale(0.5);
            
            
        var diffBulletX_enemy = player.x - enemy_archer.x;
        var diffBulletY_enemy = player.y - enemy_archer.y;
        var distanceBullet_enemy = Math.sqrt(diffBulletX_enemy * diffBulletX_enemy + diffBulletY_enemy * diffBulletY_enemy);
        var bullet_enemyAngle = Math.atan(diffBulletY_enemy/diffBulletX_enemy);
    
        enemy_bullet.setRotation(bullet_enemyAngle);
        enemy_bullet.setVelocityX( 3*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy));
        enemy_bullet.setVelocityY(3*speedBullet_enemy * (diffBulletY_enemy /distanceBullet_enemy));  
        
        

        if(archerdead==0&&current_level==2)
        {function enemybullet2_player(enemy_bullet, player) {
            if(dashing==0)
            {lives -= 1;
            enemy_bullet.setVelocity(0, 0);
            enemy_bullet.setVisible(false);
            enemy_bullet.destroy();
            }
            else
            {enemy_bullet.setVelocity(-2*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy), -2*speedBullet_enemy * (diffBulletY_enemy / distanceBullet_enemy));
        }
        }}

        

    
        if(archerdead==0&&current_level==2)
        this.physics.add.collider(enemy_bullet, player, enemybullet2_player, null, this);
    }}
    }
        
    if(lives <= 0)
        this.add.image(400, 400, 'gameover').setScale(1.6).setVisible(true);

    if( enemydead==1 && archerdead==1 && flyerdead == 1 && invisdead == 1 && bossdead == 1) {
    {this.add.image(500, 400, 'youwin').setScale(1.4).setVisible(true).setDepth(+1);
    livesCounter.setVisible(false);
    heart.setVisible(false);
    }
    }

        if (enemylives <= 0&&enemydead==0)
            {enemy.setVelocity(0, 0);
            enemy.setCollideWorldBounds(false); 
            enemy.setVisible(false);
            enemy.destroy();
            
            enemydead = 1;
            enemylives = -1;
            current_level = 2;
            key1++;
            
            
            
            }

            if(enemylives <=0&&screen1<61)
            screen1 ++;
            if(screen1==60)
            {enemy_archer.x = 900;
            enemy_archer.y = 500;}
            else
            if(screen1<60)
            {enemy_archer.x = 1500;
            enemy_archer.y = 1200;}

            if(screen1 ==1)
            screen_1 = this.add.image (500,400,'screen1').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen1 ==59)
            screen_1.destroy();

            if(archerlives <= 0 && archerdead==0)
            {enemy_archer.setVelocity(0, 0);
            enemy_archer.setCollideWorldBounds(false); 
            enemy_archer.setVisible(false);
            enemy_archer.x = 10000;
            enemy_archer.destroy();
            archerdead = 1;
            archerlives = -1;
            key2++;
            current_level = 3;
            

            }
            if(archerlives <=0&&screen2<61)
            screen2 ++;
            if(screen2==60)
            {flyer.x = 100;
            flyer.y = 550;}
            else
            if(screen2<60)
            {flyer.x = 1500;
            flyer.y = 1200;}

            if(screen2 ==1)
            screen_2 = this.add.image (500,400,'screen2').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen2 ==59)
            screen_2.destroy();

            if (flyer_lives <= 0&&flyerdead==0)
            {flyer.setVelocity(0, 0);
            flyer.setCollideWorldBounds(false); 
            flyer.setVisible(false);
            flyer.x = 10000;
            flyer.destroy();
            flyer_lives = -1;
            flyerdead = 1;
            key3++;
            current_level = 4;
            
            }
            if(flyer_lives <=0&&screen3<61)
            screen3 ++;
            if(screen3==60)
            {invis.x = 500;
            invis.y = 500;}
            else
            if(screen3<60)
            {invis.x = 1500;
            invis.y = 1200;}

            if(screen3 ==1)
            screen_3 = this.add.image (500,400,'screen3').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen3 ==59)
            screen_3.destroy();

            if (invislives <= 0&&invisdead==0)
            {invis.setVelocity(0, 0);
            invis.setCollideWorldBounds(false); 
            invis.setVisible(false);
            invis.x = 10000;
            invis.destroy();
            invislives = -1;
            invisdead = 1;
            key4++;
            current_level = 5;
           
            }   

            if(invislives <=0&&screen4<61)
            screen4 ++;
            if(screen4==60)
            {boss.x = 500;
            boss.y = 500;}
            else
            if(screen4<60)
            {boss.x = 1500;
            boss.y = 1200;}

            if(screen4 ==1)
            screen_4 = this.add.image (500,400,'screen4').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen4 ==59)
            screen_4.destroy();


            
            
            if(bosslives <= 0&&bossdead <= 0)
    {
        boss.setVelocity(0,0);
        boss.setVisible(false);
        bossheart.setVisible(false);
        boss.destroy();
        bossdead =1;
        bosslives = -1;
    }
       
        
        
        this.input.on('pointerdown',function (pointer){
            if(pointer.leftButtonDown() && bow_ammo >0 ||bow_ammo_plus==1)
            {  

                var diffBulletX = game.input.mousePointer.x-player.x;
                var diffBulletY = game.input.mousePointer.y-player.y;
                var distanceBullet = Math.sqrt(diffBulletX*diffBulletX+diffBulletY*diffBulletY);
                var speedBullet = 500;
                var bulletAngle = Math.atan(diffBulletY/diffBulletX);
                bullet.setRotation(bulletAngle);
                bullet.setVelocityX(Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt((bullettime+1)))))*speedBullet*(diffBulletX/distanceBullet));
                bullet.setVelocityY(Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt((bullettime+1)))))*speedBullet*(diffBulletY/distanceBullet)); 
                if(enemydead==0&&current_level==1)
                this.physics.add.collider(bullet, enemy);
                if(archerdead==0&&current_level==2)
                this.physics.add.collider(bullet, enemy_archer); 
                if(flyerdead==0&&current_level==3)
                this.physics.add.collider(bullet, flyer);  
            if(invisdead==0&&current_level==4)
            this.physics.add.collider(bullet, invis);
            if(bossdead==0&&current_level==5)
            this.physics.add.collider(bullet, boss);
                this.physics.add.collider(bullet, wall);
                if(bow_ammo_plus==1)
                    bow_ammo_plus=0;
            }
        },this);
        if (lives <= 0)
        {
            this.add.image(400, 400, 'gameover').setScale(1.6).setVisible(true).setDepth(+2);
            livesCounter.setVisible(false);
        }
        else
        {
livesCounter.setText(Phaser.Math.RoundTo(lives));
livesCounter.setPosition(player.x-20,player.y-player.width-10)

            //livesCounter.setVisible(false);
            //livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            livesCounter.setVisible(true);
           
heart.setPosition(player.x+15, player.y-player.width+10);
//heart.setVisible(false);
            //heart = this.physics.add.image(player.x+15, player.y-player.width+10, 'heart').setScale(3);
            heart.setVisible(true);

           
            //enemyLiveCounter.setVisible(false);
            //enemyheart.setVisible(false);
            if(enemydead == 0 && current_level==1)  
            {  
            enemyLiveCounter.setText(enemylives);
enemyLiveCounter.setPosition(enemy.x-20,enemy.y-enemy.width-10);
//enemyLiveCounter = this.add.text(enemy.x-20,enemy.y-enemy.width-10,enemylives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            enemyLiveCounter.setVisible(true);
           
enemyheart.setPosition(enemy.x+15, enemy.y-enemy.width-5);
            //enemyheart = this.physics.add.image(enemy.x+15, enemy.y-enemy.width-5, 'enemyheart').setScale(3);
            enemyheart.setVisible(true);
            } else {
enemyLiveCounter.setVisible(false);
enemyheart.setVisible(false);
}

            //enemy_archerLiveCounter.setVisible(false);
            //enemy_archerheart.setVisible(false);
            if(archerdead ==0&&current_level==2)
            {
enemy_archerLiveCounter.setText(archerlives);
enemy_archerLiveCounter.setPosition(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10);

//enemy_archerLiveCounter = this.add.text(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10,archerlives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
enemy_archerLiveCounter.setVisible(true);

enemy_archerheart.setPosition(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5);
//enemy_archerheart = this.physics.add.image(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5, 'enemyheart').setScale(3);
enemy_archerheart.setVisible(true);
} else {
enemy_archerLiveCounter.setVisible(false);
enemy_archerheart.setVisible(false);
}
           

            //bossLiveCounter.setVisible(false);
            //bossheart.setVisible(false);
            if(bossdead==0&&current_level==5)
            {
bossLiveCounter.setText(bosslives);
bossLiveCounter.setPosition(boss.x-30,boss.y-boss.width-30);
//bossLiveCounter = this.add.text(boss.x-30,boss.y-boss.width-30,bosslives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
bossLiveCounter.setVisible(true);
           
bossheart.setPosition(boss.x+15, boss.y-boss.width-15);
//bossheart = this.physics.add.image(boss.x+15, boss.y-boss.width-15, 'enemyheart').setScale(3);
bossheart.setVisible(true);
} else {
bossLiveCounter.setVisible(false);
bossheart.setVisible(false);

}

            //flyerLiveCounter.setVisible(false);
            //flyer_heart.setVisible(false);            
            if(flyerdead==0&&current_level==3)
            {
flyerLiveCounter.setText(flyer_lives);
flyerLiveCounter.setPosition(flyer.x-10,flyer.y-flyer.width-10);
//flyerLiveCounter = this.add.text(flyer.x-10,flyer.y-flyer.width-10,flyer_lives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
flyerLiveCounter.setVisible(true);
           
flyer_heart.setPosition(flyer.x+15, flyer.y-flyer.width-10);
//flyer_heart = this.physics.add.image(flyer.x+15, flyer.y-flyer.width-10, 'enemyheart').setScale(3);
flyer_heart.setVisible(true);
} else {
flyerLiveCounter.setVisible(false);
flyer_heart.setVisible(false);            
}

           
            //invisLiveCounter.setVisible(false);
            //invisheart.setVisible(false);
            if(invisdead==0&&current_level==4)
            {
invisLiveCounter.setText(invislives);
invisLiveCounter.setPosition(invis.x-20,invis.y-invis.width-10);
//invisLiveCounter = this.add.text(invis.x-20,invis.y-invis.width-10,invislives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
invisLiveCounter.setVisible(true);

invisheart.setPosition(invis.x+15, invis.y-invis.width-5);
//invisheart = this.physics.add.image(invis.x+15, invis.y-invis.width-5, 'enemyheart').setScale(3);
invisheart.setVisible(true);
} else {
invisLiveCounter.setVisible(false);
invisheart.setVisible(false);
}

        

        }
        if(dashing>0)
        dashing-=1;
    if(key1==1)
    key1_sign = this.add.image(350,100,'key1');
    if(key2==1)
    key2_sign = this.add.image(450,100,'key2');
    if(key3==1)
    key3_sign = this.add.image(550,100,'key3');
    if(key4==1)
    key4_sign = this.add.image(650,100,'key4');
    }