var config = {
    type: Phaser.AUTO,
    canvas: gameCanvas,
    physics: {
        default: 'arcade',
        arcade: {
            gravity: { y:-0 },
            debug: false
        }
    },
    scene: {
        preload: preload,
        create: create,
        update: update
    }
};

var game = new Phaser.Game(config);
var ammocounter;
var altammocounter;
var distance =0;
var distance_flyer=0;
var distance_invis = 0;
var distance_archer = 0;
var distance_boss = 0;
var wall;
var lives;
var dash_cooldown = 1;
var player;
var answer_done = 0;
var bullettime;
var current_answer;
var no_other_1;
var no_other_2;
var no_other_3;
var no_other_4;
var bow_ammo;
var pick;
var enemydead = 0;
var archerdead = 0;
var flyerdead = 0;
var invisdead = 0;
var bossdead = 0;
var current_level =1;
var key1 = 0;
var key2 = 0;
var key3 = 0;
var key4 = 0;
var stamina = 300;
var dashing = 0;
var altammo = 3;
var i;
var charge_cooldown = 0;
var j;
var enemylives;
var archerlives;
var spread;
var bosslives;
var bossBullet;
var bossAttackTime=0;
var attackEnd=1;
var counting = 0;
var speed_boss = 450;
var flyer_lives = 25;    ;
var counting_enemy = 0;
var attack_enemyend = 1;
var enemy_attacktime = 0;
var invislives = 20;
var invisspeed = 220;
var bow_ammo_plus=0;
var screen1=0;
var screen2=0;
var screen3=0;
var screen4=0;



var texts = [
    "Oblicz Logarytm o podstawie 3 z 27",
    "Oblicz 1331^(⅓)",
    "Oblicz x: x^2-16x+64=0",
    "Oblicz f(x): f(x) = x^2-2x+1, x=1001",
    "Oblicz x: x^2-x+(1/4)=0",
    "Oblicz x: |(x-2)^2| = x^2",
    "Oblicz wiek (w latach) Igora w maju 2022, jeśli urodził się w kwietniu 2019.",
    "Oblicz 12*15",
    "Oblicz 1*2+3*4+5*6+7*8",
    "Oblicz średnią arytmetyczną liczb 1,3,5,7,9,11,13,15,17,19",
    "Oblicz długość przeciwprostokątnej trójkąta prostokątnego jeżeli kąt pomiędzy podstawą a przeciwprostokątną wynosi 30 stopni, a długość wysokości opadającej na tę podstawę wynosi 5",
    "Oblicz 48*25",
    "Oblicz Logarytm o podstawie 2 z 65536",
    "Oblicz wartość funkcji f(x) = x^x dla x = -2",
    "Oblicz 17*19",
    "Oblicz 51*49",
    "Oblicz pochodną z 18x^2 + 9x + 19",
    "Oblicz pochodną z 20x",
    "Oblicz 9^3",
    "Oblicz (23+45+18+14)^4",
    "Oblicz (8129+1295+144+432)^(1-(½)-(¼))",
    "Oblicz 1000!/998!",
    "Oblicz 42*12",
    "Oblicz 1296/12",
    "Oblicz 140*27",
    "Piłka spada swobodnie bez oporów powietrza na ziemię w czasie 20 sekund Przyjmij, że g=10 m/s i oblicz wysokość z której spada piłka.",
    "Siła F = 10N nadaje wózkowi o masie 20kg pewne przyspieszenie. Jaka siła nada to samo przyspieszenie, jeśli na wózek położymy dodatkowo 10 kg ładunku?",
    "Piłka spada swobodnie bez oporów powietrza na ziemię w czasie 60 sekund. Przyjmij, że g=10 m/s i oblicz wysokość z której spada piłka.",
    "Piłka spada swobodnie bez oporów powietrza na ziemię w czasie 17 sekund. Przyjmij, że g=10 m/s i oblicz wysokość z której spada piłka.",
    "Piłka spada swobodnie bez oporów powietrza na ziemię w czasie 28 sekund. Przyjmij, że g=10 m/s i oblicz wysokość z której spada piłka.",
    "Siła F = 10N nadaje wózkowi o masie 20kg pewne przyspieszenie. Jaka siła nada to samo przyspieszenie, jeśli na wózek położymy dodatkowo 80 kg ładunku?",
    "Siła F = 10N nadaje wózkowi o masie 3kg pewne przyspieszenie. Jaka siła nada to samo przyspieszenie, jeśli na wózek położymy dodatkowo 27 kg ładunku?",
    "Siła F = 48N nadaje wózkowi o masie 12kg pewne przyspieszenie. Jaka siła nada to samo przyspieszenie, jeśli na wózek położymy dodatkowo 256kg ładunku?",
    "Wysokość cieczy w słupie wynosi 30 cm, a jej gęstość 500 kg/m3. Przyjmując, że g=10m/s, oblicz wartość ciśnienia hydrostatycznego",
    "Wysokość cieczy w słupie wynosi 50 cm, a jej gęstość 250 kg/m3. Przyjmując, że g=10m/s, oblicz wartość ciśnienia hydrostatycznego",
    "Moment siły działającej pod kątem 30 stopni wynosi 100 Nm. Oblicz długość ramienia siły, jeśli wartość siły wynosi 1000N.",
    "Sprężyna o stałej sprężystości 400 N/m wprawia w ruch ciało o masie 10 kg. Oblicz częstotliwość drgań zaokrągloną do cyfry jedności.",
    "Moment siły działającej pod kątem 30 stopni wynosi 3 Nm. Oblicz długość ramienia siły, jeśli wartość siły wynosi 60N.",
    "Moment siły działającej pod kątem 30 stopni wynosi 12 Nm. Oblicz długość ramienia siły, jeśli wartość siły wynosi 100N.",
    "Ciało o masie 10 kg i cieple właściwym 500 J/kgK na początku ma temperaturę 50 stopni Kelvina, a następnie ogrzewa się do 90. Oblicz ciepło. Przyjmij, że ciepło topnienia i wrzenia ciała nie należy do przedziału (50;90)",
    "Ciało o masie 0.4 kg i cieple właściwym 6 J/kgK na początku ma temperaturę 10 stopni Kelvina, a następnie ogrzewa się do 643. Oblicz ciepło. Przyjmij, że ciepło topnienia i wrzenia ciała nie należy do przedziału (10;643)",
    "Fala ma częstość kołową 100 rad/s i jej długość wynosi 2 m. Oblicz prędkość fali. Odpowiedź zaokrąglij do cyfry jedności.",
    "Ciało o masie 7 kg i cieple właściwym 50 J/kgK na początku ma temperaturę 56 stopni Kelvina, a następnie ogrzewa się do 60. Oblicz ciepło. Przyjmij, że ciepło topnienia i wrzenia ciała nie należy do przedziału (56;60)",
    "Fala ma częstość kołową 80 rad/s i jej długość wynosi 5 m. Oblicz prędkość fali. Odpowiedź zaokrąglij do cyfry jedności.",
    "Fala ma częstość kołową 10 rad/s i jej długość wynosi 1 m. Oblicz prędkość fali. Odpowiedź zaokrąglij do cyfry jedności.",
    "Fala ma częstość kołową 40 rad/s i jej długość wynosi 15 m. Oblicz prędkość fali. Odpowiedź zaokrąglij do cyfry jedności.",
    "Oblicz głośność, wiedząc że moc punktowego źródła wynosi 30 W, a jego promień to 10 cm.",
    "Oblicz głośność, wiedząc że moc punktowego źródła wynosi 20 W, a jego promień to 0.8 m.",
    "Oblicz głośność, wiedząc że moc punktowego źródła wynosi 40 W, a jego promień to 5 cm.",
    "Oblicz głośność, wiedząc że moc punktowego źródła wynosi 20 W, a jego średnica to 10 cm."
];
   

var ammorewards = [
    "4",
    "3",
    "5",
    "5",
    "10",
    "4",
    "6",
    "8",
    "10",
    "8",
    "8",
    "6",
    "10",
    "10",
    "15",
    "15",
    "15",
    "15",
    "15",
    "15",
    "12",
    "25",
    "20",
    "20",
    "25"
];
var liferewards = [
    "4",
    "3",
    "5",
    "5",
    "10",
    "4",
    "6",
    "8",
    "10",
    "8",
    "8",
    "6",
    "10",
    "10",
    "15",
    "15",
    "15",
    "15",
    "15",
    "15",
    "12",
    "25",
    "20",
    "20",
    "25"
];
var correct = [
    "3",
    "11",
    "8",
    "1000000",
    "1/2",
    "1",
    "3",
    "180",
    "100",
    "10",
    "10",
    "1200",
    "16",
    "1/4",
    "323",
    "2499",
    "36x+9",
    "20",
    "729",
    "100000000",
    "10",
    "999000",
    "504",
    "108",
    "3780",
    "2000m",
    "15N",
    "18000m",
    "1445m",
    "3920m",
    "50N",
    "50N",
    "100N",
    "1072N",
    "1500Pa",
    "1250Pa",
    "0.2m",
    "0.2m",
    "0.1m",
    "0.24m",
    "20000J",
    "1519.2J",
    "400m/s",
    "1400J",
    "600m/s",
    "10m/s",
    "600m/s",
    "250W/m^2",
    "2.6W/m^2",
    "13.3W/m^2",
    "166.7W/m^2"
];

var first_answers = [
    "2",
    "13",
    "16",
    "1000",
    "1/2",
    "2",
    "1",
    "120",
    "123",
    "10",
    "10",
    "1250",
    "15",
    "1/4",
    "324",
    "2500",
    "18x+9",
    "10",
    "729",
    "10000000",
    "10",
    "1000000",
    "504",
    "108",
    "3600",
    "200",
    "30N",
    "1800m",
    "2890m",
    "3920m",
    "30N",
    "80N",
    "1060N",
    "1400Pa",
    "1250Pa",
    "0,2m",
    "10Hz",
    "10cm",
    "0,2m",
    "150000J",
    "1519,2",
    "100m/s",
    "1300J",
    "100m/s",
    "2m/s",
    "300m/s",
    "250W/m^2",
    "2,6W/m^2",
    "10,3W/m^2",
    "133,3W/m^2"
];
var next_pick = Phaser.Math.Between(0, texts.length - 1);
var second_answers = [
    "4",
    "31",
    "4",
    "1000000",
    "1",
    "3",
    "5",
    "180",
    "140",
    "8",
    "5",
    "1000",
    "17",
    "1/2",
    "330",
    "2509",
    "36x+18",
    "40",
    "81",
    "1000000000",
    "100",
    "999000",
    "484",
    "128",
    "3780",
    "2000",
    "40N",
    "3600m",
    "14500m",
    "3645m",
    "40N",
    "90N",
    "1064N",
    "1500Pa",
    "1500Pa",
    "0,15m",
    "20Hz",
    "20cm",
    "0,24m",
    "1534,4",
    "1562,2",
    "200m/s",
    "1400J",
    "200m/s",
    "4m/s",
    "400m/s",
    "300W/m^2",
    "3W/m^2",
    "11,3W/m^2",
    "166,7W/m^2"    
];
var third_answers = [
    "1",
    "12",
    "8",
    "10000",
    "2",
    "1",
    "3",
    "150",
    "80",
    "11",
    "3",
    "2000",
    "16",
    "2",
    "320",
    "2499",
    "36x+9",
    "30",
    "929",
    "10000000000",
    "20",
    "998000",
    "384",
    "256",
    "3800",
    "4000",
    "15N",
    "36000m",
    "145m",
    "4205m",
    "50N",
    "100N",
    "1068N",
    "1600Pa",
    "1750Pa",
    "0,2m",
    "20Hz",
    "1m",
    "0,28m",
    "1565,6",
    "200m/s",
    "1500J",
    "400m/s",
    "5m/s",
    "600m/s",
    "350W/m^2",
    "2,6W/m^2",
    "12,3W/m^2",
    "188,9W/m^2"

];
var fourth_answers = [
    "3",
    "11",
    "2",
    "10000000",
    "4",
    "0",
    "4",
    "1800",
    "100",
    "9",
    "20",
    "1200",
    "20",
    "4",
    "323",
    "2501",
    "36x",
    "20",
    "721",
    "100000000",
    "1000",
    "10000",
    "524",
    "216",
    "4096",
    "400",
    "100N",
    "18000m",
    "14500m",
    "7840m",
    "60N",
    "110N",
    "1072N",
    "1700Pa",
    "2000Pa",
    "0,3m",
    "40Hz",
    "1cm",
    "0,32m",
    "1562,2",
    "600m/s",
    "1600J",
    "600m/s",
    "10m/s",
    "400m/s",
    "400W/m^2",
    "3,4W/m^2",
    "13,3W/m^2",
    "202,3W/m^2"
];

function preload ()
    {
            this.load.image('player', 'gracz_demo.png');
        this.load.image('enemy', 'enemy.png');
        this.load.image('enemy_archer', 'enemy_archer.png');
        this.load.image('bg', 'tlo_demo.png');
        this.load.image('wall', 'wall.png');
        this.load.image('wall2', 'wall.png');
        this.load.image('bullet', 'bullet.png');
        this.load.image('enemy_bullet', 'enemy_bullet.png');
        this.load.image('ammoimage', 'ammoimage.png');
        this.load.image('gameover', 'gameover.png');
        this.load.image('youwin', 'youwin.png');
        this.load.image('heart', 'heart.png');
        this.load.image('enemyheart', 'enemyheart.png');
        this.load.image('boss', 'boss.png');
        this.load.image('bossBullet', 'bossBullet.png');
        this.load.image('altbullet', 'altbullet.png');
        this.load.image('meleebullet', 'melee_bullet.png');
        this.load.image('flyer', 'flyer.png');
        this.load.image('invis', 'invis.png');
        this.load.image('invis_bullet', 'invisbullet.png');
        this.load.image('potion', 'potion.png');
        this.load.image('potion_floor', 'potion_floor.png');
        this.load.image('key1', 'keyshard1.png');
        this.load.image('key2', 'keyshard2.png');
        this.load.image('key3', 'keyshard3.png');
        this.load.image('key4', 'keyshard4.png');
        this.load.image('screen1', 'screen1.png');
        this.load.image('screen2','screen2.png');
        this.load.image('screen3','screen3.png');
        this.load.image('screen4','screen4.png');


    }
    bullet_enemy_cooldown = 0;
    function create ()
    {
        number = this.add.image (666,200)
        bullettime = 0;
        this.add.image(345, 120, "bg").setScale(5).setDepth(-1);
        wall = this.physics.add.staticGroup();
        wall = this.physics.add.staticGroup();
        lives = 500;    
        
        
        
        for(var i =0;i<20;i++)
        {wall.create(20+60*i,200,'wall').setImmovable(true);}
        
        for(var j =0;j<20;j++)
        {wall.create(20,10+60*j,'wall').setImmovable(true);}

        for(var j =0;j<20;j++)
        {wall.create(1000,10+60*j,'wall').setImmovable(true);}
        
        for(var i =0;i<20;i++)
        {wall.create(20+60*i,770,'wall').setImmovable(true);}

        player = this.physics.add.image(100, 300, 'player');
        player.bounce = -100;
    
        if(current_level ==1)
        {enemy = this.physics.add.image(600,300,'enemy');
        enemy.setCollideWorldBounds(true);
        }
        else
        enemy = this.physics.add.image(6000000, 30000000, 'enemy');
        

        player.setCollideWorldBounds(true); 

        enemy_archer= this.physics.add.image(500,400, 'enemy_archer');
        flyer = this.physics.add.image(300,600, 'flyer');
        invis = this.physics.add.image(700,700,'invis');
        enemy_archer.setCollideWorldBounds(true);
        invis.setCollideWorldBounds(true);
        flyer.setCollideWorldBounds(true);
        boss = this.physics.add.image(600,600,'boss'); 
        boss.setCollideWorldBounds(true);
        this.physics.add.collider(player, wall);
        this.physics.add.collider(flyer, wall);
        this.physics.add.collider(enemy, wall);
    
        this.physics.add.collider(enemy_archer, wall);
    
        this.physics.add.collider(invis, wall);
        heart = this.physics.add.image(player.x+15, player.y-player.width-5, 'heart').setScale(3);
        enemyheart = this.physics.add.image(enemy.x+15, enemy.y-enemy.width-5, 'enemyheart').setScale(3);
        invisheart = this.physics.add.image(invis.x+15, invis.y-invis.width-5, 'enemyheart').setScale(3);
        enemy_archerheart = this.physics.add.image(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5, 'enemyheart').setScale(3);
        flyer_heart = this.physics.add.image(flyer.x+15, flyer.y-flyer.width-5, 'enemyheart').setScale(3);
        livesCounter = this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        enemyLiveCounter = this.add.text(enemy.x-20,enemy.y-enemy.width-10,enemylives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        enemy_archerLiveCounter = this.add.text(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10,archerlives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        invisLiveCounter = this.add.text(invis.x-20,invis.y-invis.width-10,invislives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        flyerLiveCounter = this.add.text(flyer.x-20,flyer.y-flyer.width-10,flyer_lives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        bossLiveCounter = this.add.text(boss.x-30,boss.y-boss.width-30,bosslives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
        bossheart = this.physics.add.image(boss.x+15, boss.y-boss.width-15, 'enemyheart').setScale(3);
    
    this.physics.add.collider(boss,wall);
        this.physics.add.collider(boss,enemy);
        this.physics.add.collider(boss,enemy_archer);
        function player_enemy(player, enemy) {
            if(dashing==0)
            {lives-=0.1;
            
            }
            
        }


        function player_invis(player, invis) {
            if(dashing==0)
            {lives-=0.1;
            
            }
            
        }


        

        function player_boss(player, boss) {
            if(dashing==0)
            lives-=1;
            boss.setVisible(false); 
            boss.setVisible(true);
        }
        this.physics.add.collider(player, boss, player_boss, null, this);

        this.physics.add.collider(player, enemy, player_enemy, null, this);
        this.physics.add.collider(player, invis, player_invis, null, this);
        
        

        this.cursors = this.input.keyboard.addKeys({
            up: Phaser.Input.Keyboard.KeyCodes.W,
            down: Phaser.Input.Keyboard.KeyCodes.S,
            left: Phaser.Input.Keyboard.KeyCodes.A,
            right: Phaser.Input.Keyboard.KeyCodes.D,
            one: Phaser.Input.Keyboard.KeyCodes.ONE,
            two: Phaser.Input.Keyboard.KeyCodes.TWO,
            three: Phaser.Input.Keyboard.KeyCodes.THREE,
            four: Phaser.Input.Keyboard.KeyCodes.FOUR,
            dash: Phaser.Input.Keyboard.KeyCodes.SPACE,
        });
    bow_ammo = 20;
    var randomIndex = Phaser.Math.Between(0, texts.length - 1);

    this.input.on('pointerdown',function (pointer){
        if(pointer.leftButtonDown())
            if(bow_ammo >0)
                {  

                if(bow_ammo==1)
                    bow_ammo_plus=1;
                bow_ammo -=1;
                
                ammocounter.setText(bow_ammo);
               
                bullet = this.physics.add.image(player.x,player.y,'bullet');
               
                
                if(enemydead == 0&&current_level==1)
                { function stopBullet_enemy(bullet, enemy) {
                    enemylives-=1;
                    bullet.setVelocity(0, 0);
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }
            }

            if(invisdead == 0&&current_level==4)
            { function stopBullet_invis(bullet, invis) {
            invislives-=1;
            bullet.setVelocity(0, 0);
            bullet.setVisible(false); 
            bullet.destroy(); 
        }
    }


    if(flyerdead==0&&current_level==3)
    {function stopBullet_flyer(bullet, flyer) {
                    flyer_lives-=1;
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                function stopBullet(bullet, wall) {
                
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }
                if(archerdead==0&&current_level==2)
                {function stopBullet_enemyarcher(bullet, enemy_archer) {
                    archerlives-=1;
                    bullet.setVelocity(0, 0);
                    
                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                if(bossdead==0&&current_level==5)
                {function stopBullet_boss(bullet, boss) {
                    bosslives-=1;
                    bullet.setVelocity(0, 0);

                    bullet.setVisible(false); 
                    bullet.destroy(); 
                }}

                if(invisdead==0&&current_level==4)
                this.physics.add.collider(bullet,  invis, stopBullet_invis, null, this);
                if(flyerdead==0&&current_level==3)
                this.physics.add.collider(bullet, flyer, stopBullet_flyer, null, this);
                this.physics.add.collider(bullet, wall, stopBullet, null, this);
                if(enemydead == 0&&current_level==1)
                this.physics.add.collider(bullet, enemy, stopBullet_enemy, null, this);
            if(archerdead==0&&current_level==2)
                this.physics.add.collider(bullet, enemy_archer, stopBullet_enemyarcher, null, this);
            if(bossdead==0&&current_level==5)
                this.physics.add.collider(bullet, boss, stopBullet_boss, null, this);  
                }
                },this);
            

                this.input.on('pointerdown',function (pointer){
                    if(pointer.middleButtonDown())
                        if(altammo >0&&player.x > 90&&player.x<900&&player.y>300&&player.y<710)
                            {  
                                altammo -=1;
                            altbullet = this.physics.add.image(player.x,player.y,'altbullet');
                    
                            altammocounter.setVisible(false);
                            altammocounter =  this.add.text(820,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
                            altammocounter.setVisible(true);
                            
                            
                            if(enemydead ==0&&current_level==1)
                            {function stopBullet_enemy(altbullet, enemy) {
                                enemylives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}

                            if(invisdead ==0&&current_level==4)
                        { function stopBullet_invis(altbullet, invis) {
                                invislives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}
                
                            function stopBullet(altbullet, wall) {
                            
                                altbullet.setVelocity(0, 0);
                                
                                bullet.setVisible(false); 
                                bullet.destroy(); 
                            }
                            if(archerdead==0&&current_level==2)
                            {function stopBullet_enemyarcher(altbullet, enemy_archer) {
                                archerlives-=5;
                                altbullet.setVelocity(0, 0);
                                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }
                        }
                        if(bossdead==0&&current_level==5)    
                        {function stopBullet_boss(altbullet, boss) {
                                bosslives-=5;
                                altbullet.setVelocity(0, 0);
                
                                altbullet.setVisible(false); 
                                altbullet.destroy(); 
                            }}
                
                            
                            this.physics.add.collider(altbullet, wall, stopBullet, null, this);
                            if(enemydead == 0&&current_level==1)
                            this.physics.add.collider(altbullet, enemy, stopBullet_enemy, null, this);
                            if(invisdead==0&&current_level==4)
                            this.physics.add.collider(altbullet, invis, stopBullet_invis, null, this);
                        if(archerdead==0&&current_level==2)
                            this.physics.add.collider(altbullet, enemy_archer, stopBullet_enemyarcher, null, this);
                        if(bossdead==0&&current_level==5)
                            this.physics.add.collider(altbullet, boss, stopBullet_boss, null, this);  
                            }
                            },this);
                        
    current_answer = 10;
    group = this.add.group();    


        
        for (var i = 0; i < texts.length; i++) {
            var text = this.add.text(100, 10, texts[i],{ fontFamily: 'Arial', fontSize: 14, color: ' #0000ff ' });
            group.add(text);
            text.setVisible(false); 
        }

        

        pick = randomIndex;
        
        
        randomText = group.getChildren()[randomIndex];
        
        randomText.setVisible(true);
        ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
        ammoimage =  this.add.image(790,117,'ammoimage').setScale(0.3);
        altammocounter =  this.add.text(820,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
        altammoimage =  this.add.image(860,117,'altbullet').setScale(0.3);




    group_firsts = this.add.group();    
        
        for (var i = 0; i < first_answers.length; i++) {
            var text_first = this.add.text(100, 40, first_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_firsts.add(text_first);
            text_first.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_1 = group_firsts.getChildren()[randomIndex];
        
        randomText_1.setVisible(true);
    archerlives = 20;
    enemylives = 30;
    bosslives = 50;
    group_seconds = this.add.group();    
        
        for (var i = 0; i < second_answers.length; i++) {
            var text_second = this.add.text(100, 70, second_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_seconds.add(text_second);
            text_second.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_2 = group_seconds.getChildren()[randomIndex];
        
        randomText_2.setVisible(true);


    group_thirds = this.add.group();    
        
        for (var i = 0; i < third_answers.length; i++) {
            var text_third = this.add.text(100, 100, third_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_thirds.add(text_third);
            text_third.setVisible(false); 
        }

        
        randomIndex = pick;
        
        randomText_3 = group_thirds.getChildren()[randomIndex];
        
        randomText_3.setVisible(true);


    group_fourths = this.add.group();    
        
        for (var i = 0; i < fourth_answers.length; i++) {
            var text_fourth = this.add.text(100, 130, fourth_answers[i],{ fontFamily: 'Arial', fontSize: 20, color: ' #0000ff ' });
            group_fourths.add(text_fourth);
            text_fourth.setVisible(false); 
        }

        
        var randomIndex = pick;
        
        randomText_4 = group_fourths.getChildren()[randomIndex];
        
        randomText_4.setVisible(true);
    }



    function update ()
    {  {{{{{{{{{
        no_other_1 = 0;
        no_other_2 = 0;
        no_other_3 = 0;
        no_other_4 = 0;


        if(this.cursors.four.isUp && this.cursors.two.isUp && this.cursors.three.isUp) {
            no_other_1=1;
        }
        if(this.cursors.one.isUp && no_other_1 == 1)
            current_answer = 0;   
            
        
        if(this.cursors.one.isUp && this.cursors.three.isUp && this.cursors.four.isUp) {
            no_other_2=1;
        }    
        if(this.cursors.one.isUp && this.cursors.two.isUp && this.cursors.four.isUp) {
            no_other_3=1;
        } 
        if(this.cursors.one.isUp && this.cursors.two.isUp && this.cursors.three.isUp) {
            no_other_4=1;
        }
        
        
    if(this.cursors.one.isDown && no_other_1 == 1 && current_answer == 0)
        {current_answer = 1;
        answer_done=1;}

    if(this.cursors.two.isDown && no_other_2 == 1 && current_answer == 0)
        {current_answer = 2;
        answer_done=1;}
    if(this.cursors.three.isDown && no_other_3 == 1 && current_answer == 0)
        {current_answer = 3;
        answer_done=1;}
    if(this.cursors.four.isDown && no_other_4 == 1 && current_answer == 0)
        {current_answer = 4;
        answer_done=1;}
        

        
    if(current_answer ===1 && answer_done <2)
    {
        if(first_answers[pick] === correct[pick] )
    { bow_ammo+=Number(ammorewards[pick]);
        altammo+=Math.floor(Number(ammorewards[pick])/5);
        lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
            answer_done++
            }

            
    }
    if(current_answer ===2 && answer_done <2)
    {
        if(second_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
            answer_done++};
        
    }}

    

    if(current_answer ===3 && answer_done <2)
    {
        if(third_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
        answer_done++};
        
    }
    if(current_answer ===4 && answer_done < 2)
    {
        if(fourth_answers[pick] === correct[pick])
        {bow_ammo+=Number(ammorewards[pick]);
            altammo+=Math.floor(Number(ammorewards[pick])/5);
            lives = lives + Number(liferewards[pick]);
            livesCounter.setVisible(false);
            ammocounter.setVisible(false);
            altammocounter.setVisible(false);
            livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            ammocounter =  this.add.text(750,100,bow_ammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            altammocounter =  this.add.text(800,100,altammo,{ fontFamily: 'Arial', fontSize: 30, color: ' #0000ff ' }).setVisible(true);
            ammocounter.setVisible(true);
            altammocounter.setVisible(true);
            answer_done++;
        }
        else 
            {lives -=50;
        answer_done++;}
        
    }
    
    if(answer_done == 2) {
        randomText.setVisible(false);
        pick = (pick + next_pick) % texts.length; 
        randomText = group.getChildren()[pick];
        randomText.setVisible(true);
        randomText_1.setVisible(false);
        randomText_1 = group_firsts.getChildren()[pick];
        randomText_1.setVisible(true);
        randomText_2.setVisible(false);
        randomText_2 = group_seconds.getChildren()[pick];
        randomText_2.setVisible(true);
        randomText_3.setVisible(false);
        randomText_3 = group_thirds.getChildren()[pick];
        randomText_3.setVisible(true);
        randomText_4.setVisible(false);
        randomText_4 = group_fourths.getChildren()[pick];
        randomText_4.setVisible(true);
        answer_done =  3;
    }


    if(this.cursors.dash.isUp)
    dash_cooldown++;


    if(this.cursors.dash.isDown)
    {if(stamina >= 0 && dash_cooldown>30)
    {dashing = 10;
    stamina -=30;
    dash_cooldown = 0;
    }
    else
    stamina=(stamina+1)%300;
    }

        
        if (this.cursors.left.isDown)
        {
            player.setVelocityX(-220*(dashing/3+1));
        
        
        }
        else 
        if (this.cursors.right.isDown)
        {
            player.setVelocityX(220*(dashing/3+1));
        
        
        }
        else
        {
        player.setVelocityX(0);

        }
        
        if (this.cursors.up.isDown)
        {
            player.setVelocityY(-220*(dashing/3+1));
        
        
        }
        else if (this.cursors.down.isDown)
        {
            player.setVelocityY(220*(dashing/3+1));
        
        
        }
        
        else
        {
        player.setVelocityY(0);
        }
    if(bullettime %60 < 55&& current_level ==4)
    invis.setVisible(false);
    else
    {if(current_level==4)
    invis.setVisible(true);}

    bullettime=(bullettime+1)%600;
        if(enemydead == 0&&current_level==1)
    {var diffX = player.x - enemy.x;
        var diffY = player.y - enemy.y;
        var distance = Math.sqrt(diffX*diffX+diffY*diffY);
        }
        
        if(current_level==1)
        var speed  = 70;
        
    if(distance < 300&&current_level==1)
        { var speed = 200;
        
        }





    if(distance < 1500&& enemydead ==0&&current_level==1)
    {enemy.setVelocityX(  speed*(diffX/distance));
        enemy.setVelocityY(  speed*(diffY/distance));
    }   


    if(current_level !=2&&archerdead == 0)
    {enemy_archer.x = 1500;
    enemy_archer.y = 1000;

    }

    if(current_level !=3&&flyerdead==0)
    {flyer.x = 1500;
    flyer.y = 1000;
    }

    if(current_level !=4&&invisdead==0)
    {invis.x = 1500;
    invis.y = 1000;
    }

    if(current_level !=5&&bossdead==0)
    {boss.x = 1500;
    boss.y = 1000;
    }
    if(current_level==1)
        var shootgap = (player.x-enemy.x)/Math.abs(player.x-enemy.x);
    if(distance > 80 && distance < 1500&&current_level==1 &&bullettime%45==0&& enemydead == 0)
    {meleebullet = this.physics.add.image(enemy.x+50*shootgap, enemy.y, 'meleebullet').setScale(1.16);

            
            var speedBullet_melee = 500;
    var diffBulletX_melee = player.x - enemy.x;
    var diffBulletY_melee = player.y - enemy.y;
    var distanceBullet_melee = Math.sqrt(diffBulletX_melee * diffBulletX_melee + diffBulletY_melee * diffBulletY_melee);
    var bullet_meleeAngle = Math.atan(diffBulletY_melee/diffBulletX_melee);

    meleebullet.setRotation(bullet_meleeAngle);
    meleebullet.setVelocityX(speedBullet_melee * (diffBulletX_melee /distanceBullet_melee));  
    meleebullet.setVelocityY(speedBullet_melee * (diffBulletY_melee /distanceBullet_melee));  
    


    function meleebullet_player(meleebullet, player) {
        if(dashing==0)
        {lives -= 10;
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
        }
        else
        meleebullet.setVelocity(-2*speedBullet_melee * (diffBulletX_melee / distanceBullet_melee), -2*speedBullet_melee * (diffBulletY_melee / distanceBullet_melee));
    }

    function meleeBulletwall(meleebullet, wall) {
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
    }

    function meleebullet_enemy(meleebullet, enemy) {
        enemylives -= 1;
        meleebullet.setVelocity(0, 0);
        meleebullet.setVisible(false);
        meleebullet.destroy();
    }


    this.physics.add.collider(meleebullet, wall, meleeBulletwall, null, this);
    this.physics.add.collider(meleebullet, player, meleebullet_player, null, this);
    this.physics.add.collider(meleebullet, enemy, meleebullet_enemy, null, this);
    }}}
    if(invisdead==0&&current_level==4)
    {var diffX_invis = player.x - invis.x;
    var diffY_invis = player.y - invis.y;
    var distance_invis = Math.sqrt(diffX_invis*diffX_invis+diffY_invis*diffY_invis);}




    if(distance_invis < 1500&&current_level==4&&invisdead==0)
    {invis.setVelocityX(  invisspeed*(diffX_invis/distance_invis));
    invis.setVelocityY(  invisspeed*(diffY_invis/distance_invis));
    }   


    if(distance_invis > 250 && distance_invis < 1500 &&current_level==4&&bullettime%45<4&&invisdead==0)
    {invisbullet = this.physics.add.image(invis.x, invis.y, 'invis_bullet').setScale(1.16);
   
        
        var speedBullet_invis = 1000;
    var diffBulletX_invis = player.x - invis.x;
    var diffBulletY_invis = player.y - invis.y;
    var distanceBullet_invis = Math.sqrt(diffBulletX_invis * diffBulletX_invis + diffBulletY_invis * diffBulletY_invis);
    var bullet_invisAngle = Math.atan(diffBulletY_invis/diffBulletX_invis);

    invisbullet.setRotation(bullet_invisAngle);
    invisbullet.setVelocityX(speedBullet_invis * (diffBulletX_invis /distanceBullet_invis));  
    invisbullet.setVelocityY(speedBullet_invis * (diffBulletY_invis /distanceBullet_invis));  
   


    function invisbullet_player(invisbullet, player) {
    if(dashing==0)
    {lives -= 15;
    invisbullet.setVelocity(0, 0);
    invisbullet.setVisible(false);
    invisbullet.destroy();
    }
    else
    invisbullet.setVelocity(-2*speedBullet_invis * (diffBulletX_invis / distanceBullet_invis), -2*speedBullet_invis * (diffBulletY_invis / distanceBullet_invis));
    }

    function invisBulletwall(invisbullet, wall) {
    invisbullet.setVelocity(0, 0);
    invisbullet.setVisible(false);
    invisbullet.destroy();
    }



    this.physics.add.collider(invisbullet, wall, invisBulletwall, null, this);
    this.physics.add.collider(invisbullet, player, invisbullet_player, null, this);

    }}}



    if(flyerdead==0&&current_level==3)
    {var diffX_flyer = player.x - flyer.x;
    var diffY_flyer = player.y - flyer.y;
    var distance_flyer = Math.sqrt(diffX_flyer*diffX_flyer+diffY_flyer*diffY_flyer);}







    if(distance_flyer<1500&&flyerdead==0&&current_level==3)
    {flyer.setVelocityX(  flyer_speed*(diffX_flyer/distance_flyer));
    flyer.setVelocityY(  flyer_speed*(diffY_flyer/distance_flyer));
    }   


    if(distance_flyer < 1500 &&bullettime%60<1&&flyerdead==0&&current_level==3)
    {flyerbullet = this.physics.add.image(flyer.x, flyer.y, 'altbullet').setScale(0.5);
  

        
    

    function flyerbulletplayer(flyerbullet, player) {
    if(dashing==0)
    {lives -= 10;
    flyerbullet.setVelocity(0, 0);
    flyerbullet.setVisible(false);
    flyerbullet.destroy();
    }
    else
    flyerbullet.destroy();
    }
    function flyerBulletwall(flyerbullet, wall) {
    flyerbullet.setVelocity(0, 0);
    flyerbullet.setVisible(false);
    flyerbullet.destroy();
    }
    this.physics.add.collider(flyerbullet, wall, flyerBulletwall, null, this);
    this.physics.add.collider(flyerbullet, player, flyerbulletplayer, null, this);

    }}}








        if(archerdead==0&&current_level==2)
        {var diffX_archer = player.x - enemy_archer.x;
        var diffY_archer = player.y - enemy_archer.y;
        var distance_archer = Math.sqrt(diffX_archer*diffX_archer+diffY_archer*diffY_archer);
        var speed = 100;
        var speedBullet_enemy = 500;}

        if(bossdead==0&&current_level==5)
        {
        var diffX_boss = player.x - boss.x;
        var diffY_boss = player.y - boss.y;
        var distance_boss = Math.sqrt(diffX_boss*diffX_boss+diffY_boss*diffY_boss);
        }
        if(distance_archer < 1500&&archerdead==0&&current_level==2)
            {enemy_archer.setVelocityX(speed*(diffX_archer/distance_archer));
            enemy_archer.setVelocityY(speed*(diffY_archer/distance_archer));}
        
        if(distance_boss < 1500&&bossdead==0&&current_level==5)
        {boss.setVelocityX(speed_boss*(diffX_boss/distance_boss));
        boss.setVelocityY(speed_boss*(diffY_boss/distance_boss));}
        if(bossdead==0&&current_level==5)
        {function bossBullet_player(bossBullet, player) {
            lives -= 5;
            bossBullet.setVelocity(0, 0);
            bossBullet.setVisible(false);
            bossBullet.destroy();
        }}

        bossAttackTime+=1;
        var bossAttack = ['minigun','shoot','potion'];

        if(bossAttackTime>=240 && distance_boss < 1500&&bossdead==0&&current_level==5)
        {
            if(attackEnd == 1)
                {   
                    var randomBossAttack = Phaser.Math.RND.pick(bossAttack);
                    attackEnd = 0;
                    bossAttackTime = 0;
                }
        }

        if(randomBossAttack ==='potion'&&current_level==5)
        {
            speed_boss=0;
            attackEnd = 0;
            counting = 0;
            var potionCounting = [];
            var potionFloorCounting = [];
            for (var j = 0; j < 10; j++) {
                potion = this.physics.add.image(boss.x, boss.y, 'potion');
                potion.setVelocity(Phaser.Math.Between(-300, 300), Phaser.Math.Between(-300, 300));
                potion.setAngularVelocity(Phaser.Math.Between(-200,200));
                counting += 1;

                potionCounting.push(potion);
            }
            setTimeout(() =>{
                for(var j=0; j<potionCounting.length; j++){
                    potionCounting[j].setVelocity(0,0);
                    potionCounting[j].setAngularVelocity(0);
                }
                setTimeout(()=>{
                for(var j=0; j<potionCounting.length; j++){
                    potionCounting[j].setVisible(false);
                    potion_floor = this.physics.add.image(potionCounting[j].x,potionCounting[j].y,'potion_floor').setScale(Phaser.Math.Between(1,2.5)).setDepth(-1);
                    potion_floor.setRotation(Phaser.Math.Between(-300,300));
                    this.physics.add.overlap(potion_floor, player, potionTouch, null, this); 

                    potionFloorCounting.push(potion_floor);
                    setTimeout(()=>{
                    for(var j=0; j<potionCounting.length; j++)
                        potionFloorCounting[j].destroy();
                    },8000)
                }
                },1000);
                if (counting == 10)
                    {
                        attackEnd = 1;
                        speed_boss=210;
                    }
            },1000);
        }

        function potionTouch(player,potion_floor){
                lives-=0.3;
        }
        
        if (randomBossAttack === 'shoot'&&current_level==5) {
            attackEnd = 0;
            counting = 0;
            for (var k = 0; k < 10; k++) {
                var bossBullet = this.physics.add.image(boss.x, boss.y, 'bossBullet');
            
                bossBullet.setVelocity(Phaser.Math.Between(-1500, 1500), Phaser.Math.Between(-1500, 1500));
              
                this.physics.add.collider(bossBullet, player, bossBullet_player, null, this);
                counting += 1;
            }
            if (counting == 10)
                attackEnd = 1;
        }
        
        if(randomBossAttack === 'minigun'&&current_level==5)
        {
            speed_boss=0;
            var angle=0;
            counting=0;
            for(var i=0; i<20; i++){
                setTimeout(() => {
                    bossBullet = this.physics.add.image(boss.x,boss.y,'bossBullet');
                    angle+=30;
                    bossBullet.setVelocity(Math.cos(Phaser.Math.DegToRad(angle))*1000,Math.sin(Phaser.Math.DegToRad(angle))*1000);
                    
                    this.physics.add.collider(bossBullet,player,bossBullet_player,null,this);
                    counting +=1;
                    if(counting==20)
                    {
                        attackEnd=1;
                        speed_boss=300;
                        
                    }
                },i*250)
            }
        }
        





    if(archerdead==0&&current_level==2)
    {var archer_attack_pick =  Phaser.Math.Between(0, 1);
    }
        
        if(bullettime % 60 < 20&& distance_archer<3000&&archerdead==0&&current_level==2)
        { 
            if(archer_attack_pick==0)
            {enemy_bullet = this.physics.add.image(enemy_archer.x, enemy_archer.y, 'enemy_bullet').setScale(0.5);
            
            
            var diffBulletX_enemy = player.x - enemy_archer.x;
            var diffBulletY_enemy = player.y - enemy_archer.y;
            var distanceBullet_enemy = Math.sqrt(diffBulletX_enemy * diffBulletX_enemy + diffBulletY_enemy * diffBulletY_enemy);
            var bullet_enemyAngle = Math.atan(diffBulletY_enemy/diffBulletX_enemy);
        
            enemy_bullet.setRotation(bullet_enemyAngle);
            enemy_bullet.setVelocityX(4*(bullettime%60) + speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy));
            enemy_bullet.setVelocityY(speedBullet_enemy * (diffBulletY_enemy /distanceBullet_enemy));  
   
            
        
            function enemybullet_player(enemy_bullet, player) {
                if(dashing==0)
                {lives -= 2;
                enemy_bullet.setVelocity(0, 0);
                enemy_bullet.setVisible(false);
                enemy_bullet.destroy();
                }
                else
                enemy_bullet.setVelocity(-2*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy), -2*speedBullet_enemy * (diffBulletY_enemy / distanceBullet_enemy));
            }
        
            function enemyBulletwall(enemy_bullet, wall) {
                enemy_bullet.setVelocity(0, 0);
                enemy_bullet.setVisible(false);
                enemy_bullet.destroy();
            }
        
        
        
        
            this.physics.add.collider(enemy_bullet, wall, enemyBulletwall, null, this);
            this.physics.add.collider(enemy_bullet, player, enemybullet_player, null, this);
        }}
        else
        if(bullettime % 60 < 20&& distance_archer<3000&&archerdead==0&&current_level==2)
        {enemy_bullet = this.physics.add.image(enemy_archer.x, enemy_archer.y, 'enemy_bullet').setScale(0.5);
            
            
        var diffBulletX_enemy = player.x - enemy_archer.x;
        var diffBulletY_enemy = player.y - enemy_archer.y;
        var distanceBullet_enemy = Math.sqrt(diffBulletX_enemy * diffBulletX_enemy + diffBulletY_enemy * diffBulletY_enemy);
        var bullet_enemyAngle = Math.atan(diffBulletY_enemy/diffBulletX_enemy);
    
        enemy_bullet.setRotation(bullet_enemyAngle);
        enemy_bullet.setVelocityX( 3*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy));
        enemy_bullet.setVelocityY(3*speedBullet_enemy * (diffBulletY_enemy /distanceBullet_enemy));  
        
        

        if(archerdead==0&&current_level==2)
        {function enemybullet2_player(enemy_bullet, player) {
            if(dashing==0)
            {lives -= 1;
            enemy_bullet.setVelocity(0, 0);
            enemy_bullet.setVisible(false);
            enemy_bullet.destroy();
            }
            else
            {enemy_bullet.setVelocity(-2*speedBullet_enemy * (diffBulletX_enemy / distanceBullet_enemy), -2*speedBullet_enemy * (diffBulletY_enemy / distanceBullet_enemy));
        }
        }}

        

    
        if(archerdead==0&&current_level==2)
        this.physics.add.collider(enemy_bullet, player, enemybullet2_player, null, this);
    }}
    }
        
    if(lives <= 0)
        this.add.image(400, 400, 'gameover').setScale(1.6).setVisible(true);

    if( enemydead==1 && archerdead==1 && flyerdead == 1 && invisdead == 1 && bossdead == 1) {
    {this.add.image(500, 400, 'youwin').setScale(1.4).setVisible(true).setDepth(+1);
    livesCounter.setVisible(false);
    heart.setVisible(false);
    }
    }

        if (enemylives <= 0&&enemydead==0)
            {enemy.setVelocity(0, 0);
            enemy.setCollideWorldBounds(false); 
            enemy.setVisible(false);
            enemy.destroy();
            
            enemydead = 1;
            enemylives = -1;
            current_level = 2;
            key1++;
            
            
            
            }

            if(enemylives <=0&&screen1<61)
            screen1 ++;
            if(screen1==60)
            {enemy_archer.x = 900;
            enemy_archer.y = 500;}
            else
            if(screen1<60)
            {enemy_archer.x = 1500;
            enemy_archer.y = 1200;}

            if(screen1 ==1)
            screen_1 = this.add.image (500,400,'screen1').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen1 ==59)
            screen_1.destroy();

            if(archerlives <= 0 && archerdead==0)
            {enemy_archer.setVelocity(0, 0);
            enemy_archer.setCollideWorldBounds(false); 
            enemy_archer.setVisible(false);
            enemy_archer.x = 10000;
            enemy_archer.destroy();
            archerdead = 1;
            archerlives = -1;
            key2++;
            current_level = 3;
            

            }
            if(archerlives <=0&&screen2<61)
            screen2 ++;
            if(screen2==60)
            {flyer.x = 100;
            flyer.y = 550;}
            else
            if(screen2<60)
            {flyer.x = 1500;
            flyer.y = 1200;}

            if(screen2 ==1)
            screen_2 = this.add.image (500,400,'screen2').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen2 ==59)
            screen_2.destroy();

            if (flyer_lives <= 0&&flyerdead==0)
            {flyer.setVelocity(0, 0);
            flyer.setCollideWorldBounds(false); 
            flyer.setVisible(false);
            flyer.x = 10000;
            flyer.destroy();
            flyer_lives = -1;
            flyerdead = 1;
            key3++;
            current_level = 4;
            
            }
            if(flyer_lives <=0&&screen3<61)
            screen3 ++;
            if(screen3==60)
            {invis.x = 500;
            invis.y = 500;}
            else
            if(screen3<60)
            {invis.x = 1500;
            invis.y = 1200;}

            if(screen3 ==1)
            screen_3 = this.add.image (500,400,'screen3').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen3 ==59)
            screen_3.destroy();

            if (invislives <= 0&&invisdead==0)
            {invis.setVelocity(0, 0);
            invis.setCollideWorldBounds(false); 
            invis.setVisible(false);
            invis.x = 10000;
            invis.destroy();
            invislives = -1;
            invisdead = 1;
            key4++;
            current_level = 5;
           
            }   

            if(invislives <=0&&screen4<61)
            screen4 ++;
            if(screen4==60)
            {boss.x = 500;
            boss.y = 500;}
            else
            if(screen4<60)
            {boss.x = 1500;
            boss.y = 1200;}

            if(screen4 ==1)
            screen_4 = this.add.image (500,400,'screen4').setScale(1.333).setVisible(true).setDepth(+1);
            if(screen4 ==59)
            screen_4.destroy();


            
            
            if(bosslives <= 0&&bossdead <= 0)
    {
        boss.setVelocity(0,0);
        boss.setVisible(false);
        bossheart.setVisible(false);
        boss.destroy();
        bossdead =1;
        bosslives = -1;
    }
       
        
        
        this.input.on('pointerdown',function (pointer){
            if(pointer.leftButtonDown() && bow_ammo >0 ||bow_ammo_plus==1)
            {  

                var diffBulletX = game.input.mousePointer.x-player.x;
                var diffBulletY = game.input.mousePointer.y-player.y;
                var distanceBullet = Math.sqrt(diffBulletX*diffBulletX+diffBulletY*diffBulletY);
                var speedBullet = 500;
                var bulletAngle = Math.atan(diffBulletY/diffBulletX);
                bullet.setRotation(bulletAngle);
                bullet.setVelocityX(Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt((bullettime+1)))))*speedBullet*(diffBulletX/distanceBullet));
                bullet.setVelocityY(Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt((bullettime+1)))))*speedBullet*(diffBulletY/distanceBullet)); 
                if(enemydead==0&&current_level==1)
                this.physics.add.collider(bullet, enemy);
                if(archerdead==0&&current_level==2)
                this.physics.add.collider(bullet, enemy_archer); 
                if(flyerdead==0&&current_level==3)
                this.physics.add.collider(bullet, flyer);  
            if(invisdead==0&&current_level==4)
            this.physics.add.collider(bullet, invis);
            if(bossdead==0&&current_level==5)
            this.physics.add.collider(bullet, boss);
                this.physics.add.collider(bullet, wall);
                if(bow_ammo_plus==1)
                    bow_ammo_plus=0;
            }
        },this);
        if (lives <= 0)
        {
            this.add.image(400, 400, 'gameover').setScale(1.6).setVisible(true).setDepth(+2);
            livesCounter.setVisible(false);
        }
        else
        {
livesCounter.setText(Phaser.Math.RoundTo(lives));
livesCounter.setPosition(player.x-20,player.y-player.width-10)

            //livesCounter.setVisible(false);
            //livesCounter=this.add.text(player.x-20,player.y-player.width-10,Phaser.Math.RoundTo(lives),{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            livesCounter.setVisible(true);
           
heart.setPosition(player.x+15, player.y-player.width+10);
//heart.setVisible(false);
            //heart = this.physics.add.image(player.x+15, player.y-player.width+10, 'heart').setScale(3);
            heart.setVisible(true);

           
            //enemyLiveCounter.setVisible(false);
            //enemyheart.setVisible(false);
            if(enemydead == 0 && current_level==1)  
            {  
            enemyLiveCounter.setText(enemylives);
enemyLiveCounter.setPosition(enemy.x-20,enemy.y-enemy.width-10);
//enemyLiveCounter = this.add.text(enemy.x-20,enemy.y-enemy.width-10,enemylives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
            enemyLiveCounter.setVisible(true);
           
enemyheart.setPosition(enemy.x+15, enemy.y-enemy.width-5);
            //enemyheart = this.physics.add.image(enemy.x+15, enemy.y-enemy.width-5, 'enemyheart').setScale(3);
            enemyheart.setVisible(true);
            } else {
enemyLiveCounter.setVisible(false);
enemyheart.setVisible(false);
}

            //enemy_archerLiveCounter.setVisible(false);
            //enemy_archerheart.setVisible(false);
            if(archerdead ==0&&current_level==2)
            {
enemy_archerLiveCounter.setText(archerlives);
enemy_archerLiveCounter.setPosition(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10);

//enemy_archerLiveCounter = this.add.text(enemy_archer.x-20,enemy_archer.y-enemy_archer.width-10,archerlives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
enemy_archerLiveCounter.setVisible(true);

enemy_archerheart.setPosition(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5);
//enemy_archerheart = this.physics.add.image(enemy_archer.x+15, enemy_archer.y-enemy_archer.width-5, 'enemyheart').setScale(3);
enemy_archerheart.setVisible(true);
} else {
enemy_archerLiveCounter.setVisible(false);
enemy_archerheart.setVisible(false);
}
           

            //bossLiveCounter.setVisible(false);
            //bossheart.setVisible(false);
            if(bossdead==0&&current_level==5)
            {
bossLiveCounter.setText(bosslives);
bossLiveCounter.setPosition(boss.x-30,boss.y-boss.width-30);
//bossLiveCounter = this.add.text(boss.x-30,boss.y-boss.width-30,bosslives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
bossLiveCounter.setVisible(true);
           
bossheart.setPosition(boss.x+15, boss.y-boss.width-15);
//bossheart = this.physics.add.image(boss.x+15, boss.y-boss.width-15, 'enemyheart').setScale(3);
bossheart.setVisible(true);
} else {
bossLiveCounter.setVisible(false);
bossheart.setVisible(false);

}

            //flyerLiveCounter.setVisible(false);
            //flyer_heart.setVisible(false);            
            if(flyerdead==0&&current_level==3)
            {
flyerLiveCounter.setText(flyer_lives);
flyerLiveCounter.setPosition(flyer.x-10,flyer.y-flyer.width-10);
//flyerLiveCounter = this.add.text(flyer.x-10,flyer.y-flyer.width-10,flyer_lives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
flyerLiveCounter.setVisible(true);
           
flyer_heart.setPosition(flyer.x+15, flyer.y-flyer.width-10);
//flyer_heart = this.physics.add.image(flyer.x+15, flyer.y-flyer.width-10, 'enemyheart').setScale(3);
flyer_heart.setVisible(true);
} else {
flyerLiveCounter.setVisible(false);
flyer_heart.setVisible(false);            
}

           
            //invisLiveCounter.setVisible(false);
            //invisheart.setVisible(false);
            if(invisdead==0&&current_level==4)
            {
invisLiveCounter.setText(invislives);
invisLiveCounter.setPosition(invis.x-20,invis.y-invis.width-10);
//invisLiveCounter = this.add.text(invis.x-20,invis.y-invis.width-10,invislives,{ fontFamily: 'Arial', fontSize: 30, color: '#000000'});
invisLiveCounter.setVisible(true);

invisheart.setPosition(invis.x+15, invis.y-invis.width-5);
//invisheart = this.physics.add.image(invis.x+15, invis.y-invis.width-5, 'enemyheart').setScale(3);
invisheart.setVisible(true);
} else {
invisLiveCounter.setVisible(false);
invisheart.setVisible(false);
}

        

        }
        if(dashing>0)
        dashing-=1;
    if(key1==1)
    key1_sign = this.add.image(350,100,'key1');
    if(key2==1)
    key2_sign = this.add.image(450,100,'key2');
    if(key3==1)
    key3_sign = this.add.image(550,100,'key3');
    if(key4==1)
    key4_sign = this.add.image(650,100,'key4');
    }